/* ease-actor.c generated by valac, the Vala compiler
 * generated from ease-actor.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>


#define EASE_TYPE_ACTOR (ease_actor_get_type ())
#define EASE_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_ACTOR, EaseActor))
#define EASE_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_ACTOR, EaseActorClass))
#define EASE_IS_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_ACTOR))
#define EASE_IS_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_ACTOR))
#define EASE_ACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_ACTOR, EaseActorClass))

typedef struct _EaseActor EaseActor;
typedef struct _EaseActorClass EaseActorClass;
typedef struct _EaseActorPrivate EaseActorPrivate;

#define EASE_TYPE_SCROLLABLE_EMBED (ease_scrollable_embed_get_type ())
#define EASE_SCROLLABLE_EMBED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_SCROLLABLE_EMBED, EaseScrollableEmbed))
#define EASE_SCROLLABLE_EMBED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_SCROLLABLE_EMBED, EaseScrollableEmbedClass))
#define EASE_IS_SCROLLABLE_EMBED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_SCROLLABLE_EMBED))
#define EASE_IS_SCROLLABLE_EMBED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_SCROLLABLE_EMBED))
#define EASE_SCROLLABLE_EMBED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_SCROLLABLE_EMBED, EaseScrollableEmbedClass))

typedef struct _EaseScrollableEmbed EaseScrollableEmbed;
typedef struct _EaseScrollableEmbedClass EaseScrollableEmbedClass;

#define EASE_TYPE_EDITOR_EMBED (ease_editor_embed_get_type ())
#define EASE_EDITOR_EMBED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_EDITOR_EMBED, EaseEditorEmbed))
#define EASE_EDITOR_EMBED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_EDITOR_EMBED, EaseEditorEmbedClass))
#define EASE_IS_EDITOR_EMBED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_EDITOR_EMBED))
#define EASE_IS_EDITOR_EMBED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_EDITOR_EMBED))
#define EASE_EDITOR_EMBED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_EDITOR_EMBED, EaseEditorEmbedClass))

typedef struct _EaseEditorEmbed EaseEditorEmbed;
typedef struct _EaseEditorEmbedClass EaseEditorEmbedClass;

#define EASE_TYPE_ELEMENT (ease_element_get_type ())
#define EASE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_ELEMENT, EaseElement))
#define EASE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_ELEMENT, EaseElementClass))
#define EASE_IS_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_ELEMENT))
#define EASE_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_ELEMENT))
#define EASE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_ELEMENT, EaseElementClass))

typedef struct _EaseElement EaseElement;
typedef struct _EaseElementClass EaseElementClass;

#define EASE_TYPE_ACTOR_CONTEXT (ease_actor_context_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef enum  {
	EASE_ACTOR_CONTEXT_PRESENTATION,
	EASE_ACTOR_CONTEXT_EDITOR,
	EASE_ACTOR_CONTEXT_INSPECTOR
} EaseActorContext;

struct _EaseActor {
	ClutterGroup parent_instance;
	EaseActorPrivate * priv;
	ClutterActor* contents;
	EaseElement* element;
	EaseActorContext context;
	gboolean is_background;
};

struct _EaseActorClass {
	ClutterGroupClass parent_class;
	void (*edit) (EaseActor* self, EaseEditorEmbed* sender);
	void (*end_edit) (EaseActor* self, EaseEditorEmbed* sender);
};

struct _EaseActorPrivate {
	ClutterRectangle* editor_rect;
};


static gpointer ease_actor_parent_class = NULL;

GType ease_actor_get_type (void) G_GNUC_CONST;
GType ease_scrollable_embed_get_type (void) G_GNUC_CONST;
GType ease_editor_embed_get_type (void) G_GNUC_CONST;
GType ease_element_get_type (void) G_GNUC_CONST;
GType ease_actor_context_get_type (void) G_GNUC_CONST;
#define EASE_ACTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), EASE_TYPE_ACTOR, EaseActorPrivate))
enum  {
	EASE_ACTOR_DUMMY_PROPERTY
};
#define EASE_ACTOR_RECT_WIDTH ((guint) 1)
float ease_element_get_width (EaseElement* self);
float ease_element_get_height (EaseElement* self);
EaseActor* ease_actor_construct (GType object_type, EaseElement* e, EaseActorContext c);
float ease_element_get_x (EaseElement* self);
float ease_element_get_y (EaseElement* self);
void ease_actor_reposition (EaseActor* self);
void ease_element_set_x (EaseElement* self, float value);
void ease_element_set_y (EaseElement* self, float value);
void ease_actor_translate (EaseActor* self, float x_change, float y_change);
void ease_element_set_width (EaseElement* self, float value);
void ease_element_set_height (EaseElement* self, float value);
void ease_actor_resize (EaseActor* self, float w_change, float h_change, gboolean proportional);
void ease_actor_edit (EaseActor* self, EaseEditorEmbed* sender);
static void ease_actor_real_edit (EaseActor* self, EaseEditorEmbed* sender);
void ease_actor_end_edit (EaseActor* self, EaseEditorEmbed* sender);
static void ease_actor_real_end_edit (EaseActor* self, EaseEditorEmbed* sender);
static void ease_actor_finalize (GObject* obj);

static const ClutterColor EASE_ACTOR_RECT_COLOR = {(guchar) 0, (guchar) 0, (guchar) 0, (guchar) 0};
static const ClutterColor EASE_ACTOR_RECT_BORDER = {(guchar) 100, (guchar) 100, (guchar) 100, (guchar) 255};


#line 75 "ease-actor.vala"
EaseActor* ease_actor_construct (GType object_type, EaseElement* e, EaseActorContext c) {
#line 136 "ease-actor.c"
	EaseActor * self;
#line 75 "ease-actor.vala"
	g_return_val_if_fail (e != NULL, NULL);
#line 140 "ease-actor.c"
	self = g_object_newv (object_type, 0, NULL);
#line 77 "ease-actor.vala"
	self->element = e;
#line 78 "ease-actor.vala"
	self->context = c;
#line 79 "ease-actor.vala"
	self->is_background = FALSE;
#line 82 "ease-actor.vala"
	if (c == EASE_ACTOR_CONTEXT_EDITOR) {
#line 150 "ease-actor.c"
		ClutterRectangle* _tmp0_;
		ClutterColor _tmp1_;
#line 84 "ease-actor.vala"
		self->priv->editor_rect = (_tmp0_ = g_object_ref_sink ((ClutterRectangle*) clutter_rectangle_new_with_color (&EASE_ACTOR_RECT_COLOR)), _g_object_unref0 (self->priv->editor_rect), _tmp0_);
#line 85 "ease-actor.vala"
		clutter_rectangle_set_border_color (self->priv->editor_rect, (_tmp1_ = EASE_ACTOR_RECT_BORDER, &_tmp1_));
#line 86 "ease-actor.vala"
		clutter_rectangle_set_border_width (self->priv->editor_rect, EASE_ACTOR_RECT_WIDTH);
#line 87 "ease-actor.vala"
		clutter_actor_set_width ((ClutterActor*) self->priv->editor_rect, ease_element_get_width (e));
#line 88 "ease-actor.vala"
		clutter_actor_set_height ((ClutterActor*) self->priv->editor_rect, ease_element_get_height (e));
#line 89 "ease-actor.vala"
		clutter_container_add_actor ((ClutterContainer*) self, (ClutterActor*) self->priv->editor_rect);
#line 165 "ease-actor.c"
	}
	return self;
}


#line 98 "ease-actor.vala"
void ease_actor_reposition (EaseActor* self) {
#line 98 "ease-actor.vala"
	g_return_if_fail (self != NULL);
#line 100 "ease-actor.vala"
	clutter_actor_set_x ((ClutterActor*) self, ease_element_get_x (self->element));
#line 101 "ease-actor.vala"
	clutter_actor_set_y ((ClutterActor*) self, ease_element_get_y (self->element));
#line 102 "ease-actor.vala"
	clutter_actor_set_width ((ClutterActor*) self, ease_element_get_width (self->element));
#line 103 "ease-actor.vala"
	clutter_actor_set_height ((ClutterActor*) self, ease_element_get_height (self->element));
#line 104 "ease-actor.vala"
	clutter_actor_set_width (self->contents, clutter_actor_get_width ((ClutterActor*) self));
#line 105 "ease-actor.vala"
	clutter_actor_set_height (self->contents, clutter_actor_get_height ((ClutterActor*) self));
#line 107 "ease-actor.vala"
	if (self->priv->editor_rect != NULL) {
#line 109 "ease-actor.vala"
		clutter_actor_set_width ((ClutterActor*) self->priv->editor_rect, clutter_actor_get_width ((ClutterActor*) self));
#line 110 "ease-actor.vala"
		clutter_actor_set_height ((ClutterActor*) self->priv->editor_rect, clutter_actor_get_height ((ClutterActor*) self));
#line 193 "ease-actor.c"
	}
}


#line 122 "ease-actor.vala"
void ease_actor_translate (EaseActor* self, float x_change, float y_change) {
#line 122 "ease-actor.vala"
	g_return_if_fail (self != NULL);
#line 124 "ease-actor.vala"
	clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x ((ClutterActor*) self) + x_change);
#line 125 "ease-actor.vala"
	clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y ((ClutterActor*) self) + y_change);
#line 127 "ease-actor.vala"
	ease_element_set_x (self->element, clutter_actor_get_x ((ClutterActor*) self));
#line 128 "ease-actor.vala"
	ease_element_set_y (self->element, clutter_actor_get_y ((ClutterActor*) self));
#line 210 "ease-actor.c"
}


#line 140 "ease-actor.vala"
void ease_actor_resize (EaseActor* self, float w_change, float h_change, gboolean proportional) {
#line 140 "ease-actor.vala"
	g_return_if_fail (self != NULL);
#line 142 "ease-actor.vala"
	if (proportional) {
#line 144 "ease-actor.vala"
		if ((w_change / h_change) > (clutter_actor_get_width ((ClutterActor*) self) / clutter_actor_get_height ((ClutterActor*) self))) {
#line 146 "ease-actor.vala"
			w_change = h_change * (clutter_actor_get_width ((ClutterActor*) self) / clutter_actor_get_height ((ClutterActor*) self));
#line 224 "ease-actor.c"
		} else {
#line 148 "ease-actor.vala"
			if ((w_change / h_change) < (clutter_actor_get_width ((ClutterActor*) self) / clutter_actor_get_height ((ClutterActor*) self))) {
#line 150 "ease-actor.vala"
				h_change = w_change * (clutter_actor_get_height ((ClutterActor*) self) / clutter_actor_get_width ((ClutterActor*) self));
#line 230 "ease-actor.c"
			}
		}
	}
#line 154 "ease-actor.vala"
	if ((clutter_actor_get_width ((ClutterActor*) self) + w_change) > 1) {
#line 156 "ease-actor.vala"
		clutter_actor_set_width ((ClutterActor*) self, clutter_actor_get_width ((ClutterActor*) self) + w_change);
#line 157 "ease-actor.vala"
		clutter_actor_set_width (self->contents, clutter_actor_get_width (self->contents) + w_change);
#line 240 "ease-actor.c"
	}
#line 159 "ease-actor.vala"
	if ((clutter_actor_get_height ((ClutterActor*) self) + h_change) > 1) {
#line 161 "ease-actor.vala"
		clutter_actor_set_height ((ClutterActor*) self, clutter_actor_get_height ((ClutterActor*) self) + h_change);
#line 162 "ease-actor.vala"
		clutter_actor_set_height (self->contents, clutter_actor_get_height (self->contents) + h_change);
#line 248 "ease-actor.c"
	}
#line 165 "ease-actor.vala"
	ease_element_set_width (self->element, clutter_actor_get_width ((ClutterActor*) self));
#line 166 "ease-actor.vala"
	ease_element_set_height (self->element, clutter_actor_get_height ((ClutterActor*) self));
#line 168 "ease-actor.vala"
	if (self->priv->editor_rect != NULL) {
#line 170 "ease-actor.vala"
		clutter_actor_set_width ((ClutterActor*) self->priv->editor_rect, clutter_actor_get_width ((ClutterActor*) self));
#line 171 "ease-actor.vala"
		clutter_actor_set_height ((ClutterActor*) self->priv->editor_rect, clutter_actor_get_height ((ClutterActor*) self));
#line 260 "ease-actor.c"
	}
}


#line 180 "ease-actor.vala"
static void ease_actor_real_edit (EaseActor* self, EaseEditorEmbed* sender) {
#line 180 "ease-actor.vala"
	g_return_if_fail (self != NULL);
#line 180 "ease-actor.vala"
	g_return_if_fail (sender != NULL);
#line 271 "ease-actor.c"
}


#line 180 "ease-actor.vala"
void ease_actor_edit (EaseActor* self, EaseEditorEmbed* sender) {
#line 180 "ease-actor.vala"
	EASE_ACTOR_GET_CLASS (self)->edit (self, sender);
#line 279 "ease-actor.c"
}


#line 188 "ease-actor.vala"
static void ease_actor_real_end_edit (EaseActor* self, EaseEditorEmbed* sender) {
#line 188 "ease-actor.vala"
	g_return_if_fail (self != NULL);
#line 188 "ease-actor.vala"
	g_return_if_fail (sender != NULL);
#line 289 "ease-actor.c"
}


#line 188 "ease-actor.vala"
void ease_actor_end_edit (EaseActor* self, EaseEditorEmbed* sender) {
#line 188 "ease-actor.vala"
	EASE_ACTOR_GET_CLASS (self)->end_edit (self, sender);
#line 297 "ease-actor.c"
}


static void ease_actor_class_init (EaseActorClass * klass) {
	ease_actor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (EaseActorPrivate));
	EASE_ACTOR_CLASS (klass)->edit = ease_actor_real_edit;
	EASE_ACTOR_CLASS (klass)->end_edit = ease_actor_real_end_edit;
	G_OBJECT_CLASS (klass)->finalize = ease_actor_finalize;
}


static void ease_actor_instance_init (EaseActor * self) {
	self->priv = EASE_ACTOR_GET_PRIVATE (self);
}


static void ease_actor_finalize (GObject* obj) {
	EaseActor * self;
	self = EASE_ACTOR (obj);
	_g_object_unref0 (self->contents);
	_g_object_unref0 (self->priv->editor_rect);
	G_OBJECT_CLASS (ease_actor_parent_class)->finalize (obj);
}


GType ease_actor_get_type (void) {
	static volatile gsize ease_actor_type_id__volatile = 0;
	if (g_once_init_enter (&ease_actor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EaseActorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_actor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EaseActor), 0, (GInstanceInitFunc) ease_actor_instance_init, NULL };
		GType ease_actor_type_id;
		ease_actor_type_id = g_type_register_static (CLUTTER_TYPE_GROUP, "EaseActor", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&ease_actor_type_id__volatile, ease_actor_type_id);
	}
	return ease_actor_type_id__volatile;
}




