/* ease-element.c generated by valac, the Vala compiler
 * generated from ease-element.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <clutter/clutter.h>
#include <json-glib/json-glib.h>


#define EASE_TYPE_ELEMENT (ease_element_get_type ())
#define EASE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_ELEMENT, EaseElement))
#define EASE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_ELEMENT, EaseElementClass))
#define EASE_IS_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_ELEMENT))
#define EASE_IS_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_ELEMENT))
#define EASE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_ELEMENT, EaseElementClass))

typedef struct _EaseElement EaseElement;
typedef struct _EaseElementClass EaseElementClass;
typedef struct _EaseElementPrivate EaseElementPrivate;

#define EASE_TYPE_HTML_EXPORTER (ease_html_exporter_get_type ())
#define EASE_HTML_EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_HTML_EXPORTER, EaseHTMLExporter))
#define EASE_HTML_EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_HTML_EXPORTER, EaseHTMLExporterClass))
#define EASE_IS_HTML_EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_HTML_EXPORTER))
#define EASE_IS_HTML_EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_HTML_EXPORTER))
#define EASE_HTML_EXPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_HTML_EXPORTER, EaseHTMLExporterClass))

typedef struct _EaseHTMLExporter EaseHTMLExporter;
typedef struct _EaseHTMLExporterClass EaseHTMLExporterClass;

#define EASE_TYPE_ACTOR_CONTEXT (ease_actor_context_get_type ())

#define EASE_TYPE_ACTOR (ease_actor_get_type ())
#define EASE_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_ACTOR, EaseActor))
#define EASE_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_ACTOR, EaseActorClass))
#define EASE_IS_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_ACTOR))
#define EASE_IS_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_ACTOR))
#define EASE_ACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_ACTOR, EaseActorClass))

typedef struct _EaseActor EaseActor;
typedef struct _EaseActorClass EaseActorClass;

#define EASE_TYPE_ELEMENT_MAP (ease_element_map_get_type ())
#define EASE_ELEMENT_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_ELEMENT_MAP, EaseElementMap))
#define EASE_ELEMENT_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_ELEMENT_MAP, EaseElementMapClass))
#define EASE_IS_ELEMENT_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_ELEMENT_MAP))
#define EASE_IS_ELEMENT_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_ELEMENT_MAP))
#define EASE_ELEMENT_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_ELEMENT_MAP, EaseElementMapClass))

typedef struct _EaseElementMap EaseElementMap;
typedef struct _EaseElementMapClass EaseElementMapClass;

#define EASE_TYPE_SLIDE (ease_slide_get_type ())
#define EASE_SLIDE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_SLIDE, EaseSlide))
#define EASE_SLIDE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_SLIDE, EaseSlideClass))
#define EASE_IS_SLIDE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_SLIDE))
#define EASE_IS_SLIDE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_SLIDE))
#define EASE_SLIDE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_SLIDE, EaseSlideClass))

typedef struct _EaseSlide EaseSlide;
typedef struct _EaseSlideClass EaseSlideClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	EASE_ACTOR_CONTEXT_PRESENTATION,
	EASE_ACTOR_CONTEXT_EDITOR,
	EASE_ACTOR_CONTEXT_INSPECTOR
} EaseActorContext;

struct _EaseElement {
	GObject parent_instance;
	EaseElementPrivate * priv;
	EaseElementMap* data;
};

struct _EaseElementClass {
	GObjectClass parent_class;
	EaseElement* (*copy) (EaseElement* self);
	void (*to_html) (EaseElement* self, char** html, EaseHTMLExporter* exporter, double amount);
	void (*write_html) (EaseElement* self, char** html, EaseHTMLExporter* exporter);
	void (*cairo_render) (EaseElement* self, cairo_t* context, GError** error);
	EaseActor* (*actor) (EaseElement* self, EaseActorContext c);
	gboolean (*set_color) (EaseElement* self, ClutterColor* c);
	ClutterColor* (*get_color) (EaseElement* self);
};

struct _EaseElementPrivate {
	EaseSlide* _parent;
};


static gpointer ease_element_parent_class = NULL;

GType ease_element_get_type (void) G_GNUC_CONST;
GType ease_html_exporter_get_type (void) G_GNUC_CONST;
GType ease_actor_context_get_type (void) G_GNUC_CONST;
GType ease_actor_get_type (void) G_GNUC_CONST;
GType ease_element_map_get_type (void) G_GNUC_CONST;
GType ease_slide_get_type (void) G_GNUC_CONST;
#define EASE_ELEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), EASE_TYPE_ELEMENT, EaseElementPrivate))
enum  {
	EASE_ELEMENT_DUMMY_PROPERTY,
	EASE_ELEMENT_PARENT,
	EASE_ELEMENT_EASE_NAME,
	EASE_ELEMENT_ELEMENT_TYPE,
	EASE_ELEMENT_IDENTIFIER,
	EASE_ELEMENT_X,
	EASE_ELEMENT_Y,
	EASE_ELEMENT_WIDTH,
	EASE_ELEMENT_HEIGHT,
	EASE_ELEMENT_HAS_BEEN_EDITED,
	EASE_ELEMENT_BIND_TOP,
	EASE_ELEMENT_BIND_BOTTOM,
	EASE_ELEMENT_BIND_LEFT,
	EASE_ELEMENT_BIND_RIGHT,
	EASE_ELEMENT_EXPAND_HORIZONTALLY,
	EASE_ELEMENT_EXPAND_VERTICALLY,
	EASE_ELEMENT_TOP,
	EASE_ELEMENT_BOTTOM,
	EASE_ELEMENT_LEFT,
	EASE_ELEMENT_RIGHT
};
#define EASE_ELEMENT_THEME_WIDTH ((float) 800)
#define EASE_ELEMENT_THEME_HEIGHT ((float) 600)
EaseElement* ease_element_copy (EaseElement* self);
static EaseElement* ease_element_real_copy (EaseElement* self);
void ease_element_set_parent (EaseElement* self, EaseSlide* value);
EaseElement* ease_element_construct_with_owner (GType object_type, EaseSlide* owner);
char* ease_element_map_get (EaseElementMap* self, const char* key);
char* ease_element_get (EaseElement* self, const char* key);
void ease_element_map_set (EaseElementMap* self, const char* key, const char* val);
void ease_element_set (EaseElement* self, const char* key, const char* val);
JsonNode* ease_element_map_to_json (EaseElementMap* self);
JsonNode* ease_element_to_json (EaseElement* self);
void ease_element_write_html (EaseElement* self, char** html, EaseHTMLExporter* exporter);
void ease_html_exporter_add_progress (EaseHTMLExporter* self, double amount);
void ease_element_to_html (EaseElement* self, char** html, EaseHTMLExporter* exporter, double amount);
static void ease_element_real_to_html (EaseElement* self, char** html, EaseHTMLExporter* exporter, double amount);
static void ease_element_real_write_html (EaseElement* self, char** html, EaseHTMLExporter* exporter);
void ease_element_cairo_render (EaseElement* self, cairo_t* context, GError** error);
static void ease_element_real_cairo_render (EaseElement* self, cairo_t* context, GError** error);
EaseActor* ease_element_actor (EaseElement* self, EaseActorContext c);
static EaseActor* ease_element_real_actor (EaseElement* self, EaseActorContext c);
float ease_element_get_left (EaseElement* self);
float ease_element_get_right (EaseElement* self);
void ease_element_set_width (EaseElement* self, float value);
float ease_element_get_top (EaseElement* self);
float ease_element_get_bottom (EaseElement* self);
void ease_element_set_height (EaseElement* self, float value);
void ease_element_set_has_been_edited (EaseElement* self, gboolean value);
gboolean ease_element_get_bind_left (EaseElement* self);
void ease_element_set_x (EaseElement* self, float value);
gboolean ease_element_get_expand_horizontally (EaseElement* self);
float ease_element_get_width (EaseElement* self);
gboolean ease_element_get_bind_top (EaseElement* self);
void ease_element_set_y (EaseElement* self, float value);
gboolean ease_element_get_expand_vertically (EaseElement* self);
float ease_element_get_height (EaseElement* self);
gboolean ease_element_get_bind_right (EaseElement* self);
gboolean ease_element_get_bind_bottom (EaseElement* self);
EaseElement* ease_element_sized_element (EaseElement* self, float w, float h, gboolean is_new);
gboolean ease_element_set_color (EaseElement* self, ClutterColor* c);
static gboolean ease_element_real_set_color (EaseElement* self, ClutterColor* c);
ClutterColor* ease_element_get_color (EaseElement* self);
static ClutterColor* ease_element_real_get_color (EaseElement* self);
EaseElement* ease_element_construct (GType object_type);
EaseSlide* ease_element_get_parent (EaseElement* self);
char* ease_element_get_ease_name (EaseElement* self);
void ease_element_set_ease_name (EaseElement* self, const char* value);
char* ease_element_get_element_type (EaseElement* self);
void ease_element_set_element_type (EaseElement* self, const char* value);
char* ease_element_get_identifier (EaseElement* self);
void ease_element_set_identifier (EaseElement* self, const char* value);
float ease_element_get_x (EaseElement* self);
float ease_element_get_y (EaseElement* self);
gboolean ease_element_get_has_been_edited (EaseElement* self);
void ease_element_set_bind_top (EaseElement* self, gboolean value);
void ease_element_set_bind_bottom (EaseElement* self, gboolean value);
void ease_element_set_bind_left (EaseElement* self, gboolean value);
void ease_element_set_bind_right (EaseElement* self, gboolean value);
void ease_element_set_expand_horizontally (EaseElement* self, gboolean value);
void ease_element_set_expand_vertically (EaseElement* self, gboolean value);
void ease_element_set_top (EaseElement* self, float value);
void ease_element_set_bottom (EaseElement* self, float value);
void ease_element_set_left (EaseElement* self, float value);
void ease_element_set_right (EaseElement* self, float value);
static void ease_element_finalize (GObject* obj);
static void ease_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void ease_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 84 "ease-element.vala"
static EaseElement* ease_element_real_copy (EaseElement* self) {
#line 220 "ease-element.c"
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `ease_element_copy'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 84 "ease-element.vala"
EaseElement* ease_element_copy (EaseElement* self) {
#line 84 "ease-element.vala"
	return EASE_ELEMENT_GET_CLASS (self)->copy (self);
#line 231 "ease-element.c"
}


#line 91 "ease-element.vala"
EaseElement* ease_element_construct_with_owner (GType object_type, EaseSlide* owner) {
#line 237 "ease-element.c"
	EaseElement * self;
#line 91 "ease-element.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 91 "ease-element.vala"
	self = (EaseElement*) g_object_new (object_type, NULL);
#line 93 "ease-element.vala"
	ease_element_set_parent (self, owner);
#line 245 "ease-element.c"
	return self;
}


#line 101 "ease-element.vala"
char* ease_element_get (EaseElement* self, const char* key) {
#line 252 "ease-element.c"
	char* result = NULL;
#line 101 "ease-element.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "ease-element.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 258 "ease-element.c"
	result = ease_element_map_get (self->data, key);
#line 103 "ease-element.vala"
	return result;
#line 262 "ease-element.c"
}


#line 115 "ease-element.vala"
void ease_element_set (EaseElement* self, const char* key, const char* val) {
#line 115 "ease-element.vala"
	g_return_if_fail (self != NULL);
#line 115 "ease-element.vala"
	g_return_if_fail (key != NULL);
#line 115 "ease-element.vala"
	g_return_if_fail (val != NULL);
#line 117 "ease-element.vala"
	ease_element_map_set (self->data, key, val);
#line 276 "ease-element.c"
}


#line 125 "ease-element.vala"
JsonNode* ease_element_to_json (EaseElement* self) {
#line 282 "ease-element.c"
	JsonNode* result = NULL;
#line 125 "ease-element.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 286 "ease-element.c"
	result = ease_element_map_to_json (self->data);
#line 127 "ease-element.vala"
	return result;
#line 290 "ease-element.c"
}


#line 140 "ease-element.vala"
static void ease_element_real_to_html (EaseElement* self, char** html, EaseHTMLExporter* exporter, double amount) {
#line 140 "ease-element.vala"
	g_return_if_fail (self != NULL);
#line 140 "ease-element.vala"
	g_return_if_fail (html != NULL);
#line 140 "ease-element.vala"
	g_return_if_fail (exporter != NULL);
#line 145 "ease-element.vala"
	ease_element_write_html (self, html, exporter);
#line 148 "ease-element.vala"
	ease_html_exporter_add_progress (exporter, amount);
#line 306 "ease-element.c"
}


#line 140 "ease-element.vala"
void ease_element_to_html (EaseElement* self, char** html, EaseHTMLExporter* exporter, double amount) {
#line 140 "ease-element.vala"
	EASE_ELEMENT_GET_CLASS (self)->to_html (self, html, exporter, amount);
#line 314 "ease-element.c"
}


#line 157 "ease-element.vala"
static void ease_element_real_write_html (EaseElement* self, char** html, EaseHTMLExporter* exporter) {
#line 320 "ease-element.c"
	g_return_if_fail (self != NULL);
	g_critical ("Type `%s' does not implement abstract method `ease_element_write_html'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 157 "ease-element.vala"
void ease_element_write_html (EaseElement* self, char** html, EaseHTMLExporter* exporter) {
#line 157 "ease-element.vala"
	EASE_ELEMENT_GET_CLASS (self)->write_html (self, html, exporter);
#line 331 "ease-element.c"
}


#line 164 "ease-element.vala"
static void ease_element_real_cairo_render (EaseElement* self, cairo_t* context, GError** error) {
#line 337 "ease-element.c"
	g_return_if_fail (self != NULL);
	g_critical ("Type `%s' does not implement abstract method `ease_element_cairo_render'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 164 "ease-element.vala"
void ease_element_cairo_render (EaseElement* self, cairo_t* context, GError** error) {
#line 164 "ease-element.vala"
	EASE_ELEMENT_GET_CLASS (self)->cairo_render (self, context, error);
#line 348 "ease-element.c"
}


#line 171 "ease-element.vala"
static EaseActor* ease_element_real_actor (EaseElement* self, EaseActorContext c) {
#line 354 "ease-element.c"
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `ease_element_actor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 171 "ease-element.vala"
EaseActor* ease_element_actor (EaseElement* self, EaseActorContext c) {
#line 171 "ease-element.vala"
	return EASE_ELEMENT_GET_CLASS (self)->actor (self, c);
#line 365 "ease-element.c"
}


#line 183 "ease-element.vala"
EaseElement* ease_element_sized_element (EaseElement* self, float w, float h, gboolean is_new) {
#line 371 "ease-element.c"
	EaseElement* result = NULL;
	EaseElement* element;
	float x_diff;
	float y_diff;
#line 183 "ease-element.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 186 "ease-element.vala"
	element = ease_element_copy (self);
#line 189 "ease-element.vala"
	x_diff = (w - EASE_ELEMENT_THEME_WIDTH) / 2;
#line 190 "ease-element.vala"
	y_diff = (h - EASE_ELEMENT_THEME_HEIGHT) / 2;
#line 193 "ease-element.vala"
	ease_element_set_width (element, (EASE_ELEMENT_THEME_WIDTH - ease_element_get_left (self)) - ease_element_get_right (self));
#line 194 "ease-element.vala"
	ease_element_set_height (element, (EASE_ELEMENT_THEME_HEIGHT - ease_element_get_top (self)) - ease_element_get_bottom (self));
#line 197 "ease-element.vala"
	ease_element_set_has_been_edited (element, !is_new);
#line 200 "ease-element.vala"
	if (ease_element_get_bind_left (self)) {
#line 202 "ease-element.vala"
		ease_element_set_x (element, ease_element_get_left (self));
#line 204 "ease-element.vala"
		if (ease_element_get_expand_horizontally (self)) {
#line 206 "ease-element.vala"
			ease_element_set_width (element, ease_element_get_width (element) + x_diff);
#line 398 "ease-element.c"
		}
	} else {
#line 211 "ease-element.vala"
		ease_element_set_x (element, ease_element_get_left (self) + x_diff);
#line 403 "ease-element.c"
	}
#line 215 "ease-element.vala"
	if (ease_element_get_bind_top (self)) {
#line 217 "ease-element.vala"
		ease_element_set_y (element, ease_element_get_top (self));
#line 219 "ease-element.vala"
		if (ease_element_get_expand_vertically (self)) {
#line 221 "ease-element.vala"
			ease_element_set_height (element, ease_element_get_height (element) + y_diff);
#line 413 "ease-element.c"
		}
	} else {
#line 226 "ease-element.vala"
		ease_element_set_y (element, ease_element_get_top (self) + y_diff);
#line 418 "ease-element.c"
	}
#line 230 "ease-element.vala"
	if (ease_element_get_bind_right (self)) {
#line 232 "ease-element.vala"
		if (ease_element_get_expand_horizontally (self)) {
#line 234 "ease-element.vala"
			ease_element_set_width (element, ease_element_get_width (element) + x_diff);
#line 426 "ease-element.c"
		}
	}
#line 239 "ease-element.vala"
	if (ease_element_get_bind_bottom (self)) {
#line 241 "ease-element.vala"
		if (ease_element_get_expand_vertically (self)) {
#line 243 "ease-element.vala"
			ease_element_set_height (element, ease_element_get_height (element) + y_diff);
#line 435 "ease-element.c"
		}
	}
	result = element;
#line 247 "ease-element.vala"
	return result;
#line 441 "ease-element.c"
}


#line 257 "ease-element.vala"
static gboolean ease_element_real_set_color (EaseElement* self, ClutterColor* c) {
#line 447 "ease-element.c"
	gboolean result = FALSE;
#line 257 "ease-element.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 451 "ease-element.c"
	result = FALSE;
#line 259 "ease-element.vala"
	return result;
#line 455 "ease-element.c"
}


#line 257 "ease-element.vala"
gboolean ease_element_set_color (EaseElement* self, ClutterColor* c) {
#line 257 "ease-element.vala"
	return EASE_ELEMENT_GET_CLASS (self)->set_color (self, c);
#line 463 "ease-element.c"
}


#line 267 "ease-element.vala"
static ClutterColor* ease_element_real_get_color (EaseElement* self) {
#line 469 "ease-element.c"
	ClutterColor* result = NULL;
#line 267 "ease-element.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 473 "ease-element.c"
	result = NULL;
#line 269 "ease-element.vala"
	return result;
#line 477 "ease-element.c"
}


#line 267 "ease-element.vala"
ClutterColor* ease_element_get_color (EaseElement* self) {
#line 267 "ease-element.vala"
	return EASE_ELEMENT_GET_CLASS (self)->get_color (self);
#line 485 "ease-element.c"
}


#line 57 "ease-element.vala"
EaseElement* ease_element_construct (GType object_type) {
#line 491 "ease-element.c"
	EaseElement * self;
#line 57 "ease-element.vala"
	self = (EaseElement*) g_object_new (object_type, NULL);
#line 495 "ease-element.c"
	return self;
}


EaseSlide* ease_element_get_parent (EaseElement* self) {
	EaseSlide* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_parent;
#line 72 "ease-element.vala"
	return result;
#line 506 "ease-element.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void ease_element_set_parent (EaseElement* self, EaseSlide* value) {
	EaseSlide* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_parent = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_parent), _tmp0_);
	g_object_notify ((GObject *) self, "parent");
}


char* ease_element_get_ease_name (EaseElement* self) {
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = ease_element_map_get (self->data, "ease_name");
#line 277 "ease-element.vala"
	return result;
#line 529 "ease-element.c"
}


void ease_element_set_ease_name (EaseElement* self, const char* value) {
	g_return_if_fail (self != NULL);
#line 278 "ease-element.vala"
	ease_element_map_set (self->data, "ease_name", value);
#line 537 "ease-element.c"
	g_object_notify ((GObject *) self, "ease-name");
}


char* ease_element_get_element_type (EaseElement* self) {
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = ease_element_map_get (self->data, "element_type");
#line 286 "ease-element.vala"
	return result;
#line 548 "ease-element.c"
}


void ease_element_set_element_type (EaseElement* self, const char* value) {
	g_return_if_fail (self != NULL);
#line 287 "ease-element.vala"
	ease_element_map_set (self->data, "element_type", value);
#line 556 "ease-element.c"
	g_object_notify ((GObject *) self, "element-type");
}


char* ease_element_get_identifier (EaseElement* self) {
	char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = ease_element_map_get (self->data, "identifier");
#line 295 "ease-element.vala"
	return result;
#line 567 "ease-element.c"
}


void ease_element_set_identifier (EaseElement* self, const char* value) {
	g_return_if_fail (self != NULL);
#line 296 "ease-element.vala"
	ease_element_map_set (self->data, "identifier", value);
#line 575 "ease-element.c"
	g_object_notify ((GObject *) self, "identifier");
}


float ease_element_get_x (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "x"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 306 "ease-element.vala"
	return result;
#line 588 "ease-element.c"
}


void ease_element_set_x (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 310 "ease-element.vala"
	ease_element_map_set (self->data, "x", _tmp2_ = g_strdup_printf ("%g", value));
#line 597 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "x");
}


float ease_element_get_y (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "y"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 321 "ease-element.vala"
	return result;
#line 611 "ease-element.c"
}


void ease_element_set_y (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 325 "ease-element.vala"
	ease_element_map_set (self->data, "y", _tmp2_ = g_strdup_printf ("%g", value));
#line 620 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "y");
}


float ease_element_get_width (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "width"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 336 "ease-element.vala"
	return result;
#line 634 "ease-element.c"
}


void ease_element_set_width (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 340 "ease-element.vala"
	ease_element_map_set (self->data, "width", _tmp2_ = g_strdup_printf ("%g", value));
#line 643 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "width");
}


float ease_element_get_height (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "height"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 351 "ease-element.vala"
	return result;
#line 657 "ease-element.c"
}


void ease_element_set_height (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 355 "ease-element.vala"
	ease_element_map_set (self->data, "height", _tmp2_ = g_strdup_printf ("%g", value));
#line 666 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "height");
}


#line 1056 "glib-2.0.vapi"
static gboolean string_to_bool (const char* self) {
#line 674 "ease-element.c"
	gboolean result = FALSE;
#line 1056 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1057 "glib-2.0.vapi"
	if (_vala_strcmp0 (self, "true") == 0) {
#line 680 "ease-element.c"
		result = TRUE;
#line 1058 "glib-2.0.vapi"
		return result;
#line 684 "ease-element.c"
	} else {
		result = FALSE;
#line 1060 "glib-2.0.vapi"
		return result;
#line 689 "ease-element.c"
	}
}


gboolean ease_element_get_has_been_edited (EaseElement* self) {
	gboolean result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (_tmp1_ = string_to_bool (_tmp0_ = ease_element_map_get (self->data, "has_been_edited")), _g_free0 (_tmp0_), _tmp1_);
#line 364 "ease-element.vala"
	return result;
#line 702 "ease-element.c"
}


#line 35 "glib-2.0.vapi"
static char* bool_to_string (gboolean self) {
#line 708 "ease-element.c"
	char* result = NULL;
#line 36 "glib-2.0.vapi"
	if (self) {
#line 712 "ease-element.c"
		result = g_strdup ("true");
#line 37 "glib-2.0.vapi"
		return result;
#line 716 "ease-element.c"
	} else {
		result = g_strdup ("false");
#line 39 "glib-2.0.vapi"
		return result;
#line 721 "ease-element.c"
	}
}


void ease_element_set_has_been_edited (EaseElement* self, gboolean value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 365 "ease-element.vala"
	ease_element_map_set (self->data, "has_been_edited", _tmp2_ = bool_to_string (value));
#line 731 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "has-been-edited");
}


gboolean ease_element_get_bind_top (EaseElement* self) {
	gboolean result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (_tmp1_ = string_to_bool (_tmp0_ = ease_element_map_get (self->data, "bind_top")), _g_free0 (_tmp0_), _tmp1_);
#line 377 "ease-element.vala"
	return result;
#line 745 "ease-element.c"
}


void ease_element_set_bind_top (EaseElement* self, gboolean value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 378 "ease-element.vala"
	ease_element_map_set (self->data, "bind_top", _tmp2_ = bool_to_string (value));
#line 754 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "bind-top");
}


gboolean ease_element_get_bind_bottom (EaseElement* self) {
	gboolean result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (_tmp1_ = string_to_bool (_tmp0_ = ease_element_map_get (self->data, "bind_bottom")), _g_free0 (_tmp0_), _tmp1_);
#line 390 "ease-element.vala"
	return result;
#line 768 "ease-element.c"
}


void ease_element_set_bind_bottom (EaseElement* self, gboolean value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 391 "ease-element.vala"
	ease_element_map_set (self->data, "bind_bottom", _tmp2_ = bool_to_string (value));
#line 777 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "bind-bottom");
}


gboolean ease_element_get_bind_left (EaseElement* self) {
	gboolean result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (_tmp1_ = string_to_bool (_tmp0_ = ease_element_map_get (self->data, "bind_left")), _g_free0 (_tmp0_), _tmp1_);
#line 403 "ease-element.vala"
	return result;
#line 791 "ease-element.c"
}


void ease_element_set_bind_left (EaseElement* self, gboolean value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 404 "ease-element.vala"
	ease_element_map_set (self->data, "bind_left", _tmp2_ = bool_to_string (value));
#line 800 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "bind-left");
}


gboolean ease_element_get_bind_right (EaseElement* self) {
	gboolean result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (_tmp1_ = string_to_bool (_tmp0_ = ease_element_map_get (self->data, "bind_right")), _g_free0 (_tmp0_), _tmp1_);
#line 416 "ease-element.vala"
	return result;
#line 814 "ease-element.c"
}


void ease_element_set_bind_right (EaseElement* self, gboolean value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 417 "ease-element.vala"
	ease_element_map_set (self->data, "bind_right", _tmp2_ = bool_to_string (value));
#line 823 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "bind-right");
}


gboolean ease_element_get_expand_horizontally (EaseElement* self) {
	gboolean result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (_tmp1_ = string_to_bool (_tmp0_ = ease_element_map_get (self->data, "expand_horizontally")), _g_free0 (_tmp0_), _tmp1_);
#line 429 "ease-element.vala"
	return result;
#line 837 "ease-element.c"
}


void ease_element_set_expand_horizontally (EaseElement* self, gboolean value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 430 "ease-element.vala"
	ease_element_map_set (self->data, "expand_horizontally", _tmp2_ = bool_to_string (value));
#line 846 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "expand-horizontally");
}


gboolean ease_element_get_expand_vertically (EaseElement* self) {
	gboolean result;
	char* _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (_tmp1_ = string_to_bool (_tmp0_ = ease_element_map_get (self->data, "expand_vertically")), _g_free0 (_tmp0_), _tmp1_);
#line 442 "ease-element.vala"
	return result;
#line 860 "ease-element.c"
}


void ease_element_set_expand_vertically (EaseElement* self, gboolean value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 443 "ease-element.vala"
	ease_element_map_set (self->data, "expand_vertically", _tmp2_ = bool_to_string (value));
#line 869 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "expand-vertically");
}


float ease_element_get_top (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "top"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 451 "ease-element.vala"
	return result;
#line 883 "ease-element.c"
}


void ease_element_set_top (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 452 "ease-element.vala"
	ease_element_map_set (self->data, "top", _tmp2_ = g_strdup_printf ("%g", value));
#line 892 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "top");
}


float ease_element_get_bottom (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "bottom"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 460 "ease-element.vala"
	return result;
#line 906 "ease-element.c"
}


void ease_element_set_bottom (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 461 "ease-element.vala"
	ease_element_map_set (self->data, "bottom", _tmp2_ = g_strdup_printf ("%g", value));
#line 915 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "bottom");
}


float ease_element_get_left (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "left"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 469 "ease-element.vala"
	return result;
#line 929 "ease-element.c"
}


void ease_element_set_left (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 470 "ease-element.vala"
	ease_element_map_set (self->data, "left", _tmp2_ = g_strdup_printf ("%g", value));
#line 938 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "left");
}


float ease_element_get_right (EaseElement* self) {
	float result;
	char* _tmp0_;
	float _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (_tmp1_ = (float) g_ascii_strtod (_tmp0_ = ease_element_map_get (self->data, "right"), NULL), _g_free0 (_tmp0_), _tmp1_);
#line 478 "ease-element.vala"
	return result;
#line 952 "ease-element.c"
}


void ease_element_set_right (EaseElement* self, float value) {
	char* _tmp2_;
	g_return_if_fail (self != NULL);
#line 479 "ease-element.vala"
	ease_element_map_set (self->data, "right", _tmp2_ = g_strdup_printf ("%g", value));
#line 961 "ease-element.c"
	_g_free0 (_tmp2_);
	g_object_notify ((GObject *) self, "right");
}


static void ease_element_class_init (EaseElementClass * klass) {
	ease_element_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (EaseElementPrivate));
	EASE_ELEMENT_CLASS (klass)->copy = ease_element_real_copy;
	EASE_ELEMENT_CLASS (klass)->to_html = ease_element_real_to_html;
	EASE_ELEMENT_CLASS (klass)->write_html = ease_element_real_write_html;
	EASE_ELEMENT_CLASS (klass)->cairo_render = ease_element_real_cairo_render;
	EASE_ELEMENT_CLASS (klass)->actor = ease_element_real_actor;
	EASE_ELEMENT_CLASS (klass)->set_color = ease_element_real_set_color;
	EASE_ELEMENT_CLASS (klass)->get_color = ease_element_real_get_color;
	G_OBJECT_CLASS (klass)->get_property = ease_element_get_property;
	G_OBJECT_CLASS (klass)->set_property = ease_element_set_property;
	G_OBJECT_CLASS (klass)->finalize = ease_element_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_PARENT, g_param_spec_object ("parent", "parent", "parent", EASE_TYPE_SLIDE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_EASE_NAME, g_param_spec_string ("ease-name", "ease-name", "ease-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_ELEMENT_TYPE, g_param_spec_string ("element-type", "element-type", "element-type", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_IDENTIFIER, g_param_spec_string ("identifier", "identifier", "identifier", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_X, g_param_spec_float ("x", "x", "x", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_Y, g_param_spec_float ("y", "y", "y", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_WIDTH, g_param_spec_float ("width", "width", "width", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_HEIGHT, g_param_spec_float ("height", "height", "height", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_HAS_BEEN_EDITED, g_param_spec_boolean ("has-been-edited", "has-been-edited", "has-been-edited", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_BIND_TOP, g_param_spec_boolean ("bind-top", "bind-top", "bind-top", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_BIND_BOTTOM, g_param_spec_boolean ("bind-bottom", "bind-bottom", "bind-bottom", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_BIND_LEFT, g_param_spec_boolean ("bind-left", "bind-left", "bind-left", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_BIND_RIGHT, g_param_spec_boolean ("bind-right", "bind-right", "bind-right", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_EXPAND_HORIZONTALLY, g_param_spec_boolean ("expand-horizontally", "expand-horizontally", "expand-horizontally", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_EXPAND_VERTICALLY, g_param_spec_boolean ("expand-vertically", "expand-vertically", "expand-vertically", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_TOP, g_param_spec_float ("top", "top", "top", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_BOTTOM, g_param_spec_float ("bottom", "bottom", "bottom", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_LEFT, g_param_spec_float ("left", "left", "left", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_ELEMENT_RIGHT, g_param_spec_float ("right", "right", "right", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void ease_element_instance_init (EaseElement * self) {
	self->priv = EASE_ELEMENT_GET_PRIVATE (self);
}


static void ease_element_finalize (GObject* obj) {
	EaseElement * self;
	self = EASE_ELEMENT (obj);
	_g_object_unref0 (self->priv->_parent);
	_g_object_unref0 (self->data);
	G_OBJECT_CLASS (ease_element_parent_class)->finalize (obj);
}


GType ease_element_get_type (void) {
	static volatile gsize ease_element_type_id__volatile = 0;
	if (g_once_init_enter (&ease_element_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EaseElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EaseElement), 0, (GInstanceInitFunc) ease_element_instance_init, NULL };
		GType ease_element_type_id;
		ease_element_type_id = g_type_register_static (G_TYPE_OBJECT, "EaseElement", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&ease_element_type_id__volatile, ease_element_type_id);
	}
	return ease_element_type_id__volatile;
}


static void ease_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	EaseElement * self;
	self = EASE_ELEMENT (object);
	switch (property_id) {
		case EASE_ELEMENT_PARENT:
		g_value_set_object (value, ease_element_get_parent (self));
		break;
		case EASE_ELEMENT_EASE_NAME:
		g_value_take_string (value, ease_element_get_ease_name (self));
		break;
		case EASE_ELEMENT_ELEMENT_TYPE:
		g_value_take_string (value, ease_element_get_element_type (self));
		break;
		case EASE_ELEMENT_IDENTIFIER:
		g_value_take_string (value, ease_element_get_identifier (self));
		break;
		case EASE_ELEMENT_X:
		g_value_set_float (value, ease_element_get_x (self));
		break;
		case EASE_ELEMENT_Y:
		g_value_set_float (value, ease_element_get_y (self));
		break;
		case EASE_ELEMENT_WIDTH:
		g_value_set_float (value, ease_element_get_width (self));
		break;
		case EASE_ELEMENT_HEIGHT:
		g_value_set_float (value, ease_element_get_height (self));
		break;
		case EASE_ELEMENT_HAS_BEEN_EDITED:
		g_value_set_boolean (value, ease_element_get_has_been_edited (self));
		break;
		case EASE_ELEMENT_BIND_TOP:
		g_value_set_boolean (value, ease_element_get_bind_top (self));
		break;
		case EASE_ELEMENT_BIND_BOTTOM:
		g_value_set_boolean (value, ease_element_get_bind_bottom (self));
		break;
		case EASE_ELEMENT_BIND_LEFT:
		g_value_set_boolean (value, ease_element_get_bind_left (self));
		break;
		case EASE_ELEMENT_BIND_RIGHT:
		g_value_set_boolean (value, ease_element_get_bind_right (self));
		break;
		case EASE_ELEMENT_EXPAND_HORIZONTALLY:
		g_value_set_boolean (value, ease_element_get_expand_horizontally (self));
		break;
		case EASE_ELEMENT_EXPAND_VERTICALLY:
		g_value_set_boolean (value, ease_element_get_expand_vertically (self));
		break;
		case EASE_ELEMENT_TOP:
		g_value_set_float (value, ease_element_get_top (self));
		break;
		case EASE_ELEMENT_BOTTOM:
		g_value_set_float (value, ease_element_get_bottom (self));
		break;
		case EASE_ELEMENT_LEFT:
		g_value_set_float (value, ease_element_get_left (self));
		break;
		case EASE_ELEMENT_RIGHT:
		g_value_set_float (value, ease_element_get_right (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void ease_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	EaseElement * self;
	self = EASE_ELEMENT (object);
	switch (property_id) {
		case EASE_ELEMENT_PARENT:
		ease_element_set_parent (self, g_value_get_object (value));
		break;
		case EASE_ELEMENT_EASE_NAME:
		ease_element_set_ease_name (self, g_value_get_string (value));
		break;
		case EASE_ELEMENT_ELEMENT_TYPE:
		ease_element_set_element_type (self, g_value_get_string (value));
		break;
		case EASE_ELEMENT_IDENTIFIER:
		ease_element_set_identifier (self, g_value_get_string (value));
		break;
		case EASE_ELEMENT_X:
		ease_element_set_x (self, g_value_get_float (value));
		break;
		case EASE_ELEMENT_Y:
		ease_element_set_y (self, g_value_get_float (value));
		break;
		case EASE_ELEMENT_WIDTH:
		ease_element_set_width (self, g_value_get_float (value));
		break;
		case EASE_ELEMENT_HEIGHT:
		ease_element_set_height (self, g_value_get_float (value));
		break;
		case EASE_ELEMENT_HAS_BEEN_EDITED:
		ease_element_set_has_been_edited (self, g_value_get_boolean (value));
		break;
		case EASE_ELEMENT_BIND_TOP:
		ease_element_set_bind_top (self, g_value_get_boolean (value));
		break;
		case EASE_ELEMENT_BIND_BOTTOM:
		ease_element_set_bind_bottom (self, g_value_get_boolean (value));
		break;
		case EASE_ELEMENT_BIND_LEFT:
		ease_element_set_bind_left (self, g_value_get_boolean (value));
		break;
		case EASE_ELEMENT_BIND_RIGHT:
		ease_element_set_bind_right (self, g_value_get_boolean (value));
		break;
		case EASE_ELEMENT_EXPAND_HORIZONTALLY:
		ease_element_set_expand_horizontally (self, g_value_get_boolean (value));
		break;
		case EASE_ELEMENT_EXPAND_VERTICALLY:
		ease_element_set_expand_vertically (self, g_value_get_boolean (value));
		break;
		case EASE_ELEMENT_TOP:
		ease_element_set_top (self, g_value_get_float (value));
		break;
		case EASE_ELEMENT_BOTTOM:
		ease_element_set_bottom (self, g_value_get_float (value));
		break;
		case EASE_ELEMENT_LEFT:
		ease_element_set_left (self, g_value_get_float (value));
		break;
		case EASE_ELEMENT_RIGHT:
		ease_element_set_right (self, g_value_get_float (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




