/* ease-handle.c generated by valac, the Vala compiler
 * generated from ease-handle.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define EASE_TYPE_HANDLE (ease_handle_get_type ())
#define EASE_HANDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_HANDLE, EaseHandle))
#define EASE_HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_HANDLE, EaseHandleClass))
#define EASE_IS_HANDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_HANDLE))
#define EASE_IS_HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_HANDLE))
#define EASE_HANDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_HANDLE, EaseHandleClass))

typedef struct _EaseHandle EaseHandle;
typedef struct _EaseHandleClass EaseHandleClass;
typedef struct _EaseHandlePrivate EaseHandlePrivate;

#define EASE_TYPE_HANDLE_POSITION (ease_handle_position_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define EASE_TYPE_ACTOR (ease_actor_get_type ())
#define EASE_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_ACTOR, EaseActor))
#define EASE_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_ACTOR, EaseActorClass))
#define EASE_IS_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_ACTOR))
#define EASE_IS_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_ACTOR))
#define EASE_ACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_ACTOR, EaseActorClass))

typedef struct _EaseActor EaseActor;
typedef struct _EaseActorClass EaseActorClass;

struct _EaseHandle {
	ClutterTexture parent_instance;
	EaseHandlePrivate * priv;
};

struct _EaseHandleClass {
	ClutterTextureClass parent_class;
};

typedef enum  {
	EASE_HANDLE_POSITION_TOP_LEFT = 0,
	EASE_HANDLE_POSITION_TOP_RIGHT = 1,
	EASE_HANDLE_POSITION_TOP = 2,
	EASE_HANDLE_POSITION_LEFT = 3,
	EASE_HANDLE_POSITION_RIGHT = 4,
	EASE_HANDLE_POSITION_BOTTOM_LEFT = 5,
	EASE_HANDLE_POSITION_BOTTOM_RIGHT = 6,
	EASE_HANDLE_POSITION_BOTTOM = 7
} EaseHandlePosition;

struct _EaseHandlePrivate {
	EaseHandlePosition position;
	gboolean flipped;
};


static gpointer ease_handle_parent_class = NULL;

GType ease_handle_get_type (void) G_GNUC_CONST;
GType ease_handle_position_get_type (void) G_GNUC_CONST;
#define EASE_HANDLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), EASE_TYPE_HANDLE, EaseHandlePrivate))
enum  {
	EASE_HANDLE_DUMMY_PROPERTY
};
#define EASE_HANDLE_W_PATH "handle-white.svg"
#define EASE_HANDLE_B_PATH "handle-black.svg"
char* ease_data_path (const char* path);
#define EASE_TEMP_IMG_DIR "svg"
EaseHandle* ease_handle_new (EaseHandlePosition pos);
EaseHandle* ease_handle_construct (GType object_type, EaseHandlePosition pos);
GType ease_actor_get_type (void) G_GNUC_CONST;
void ease_actor_translate (EaseActor* self, float x_change, float y_change);
void ease_actor_resize (EaseActor* self, float w_change, float h_change, gboolean proportional);
void ease_handle_drag (EaseHandle* self, float change_x, float change_y, EaseActor* target, gboolean prop);
void ease_handle_drag_from_center (EaseHandle* self, float change_x, float change_y, EaseActor* target, gboolean prop);
void ease_handle_reposition (EaseHandle* self, ClutterActor* selection);
void ease_handle_flip (EaseHandle* self);
static void ease_handle_finalize (GObject* obj);



#line 50 "ease-handle.vala"
EaseHandle* ease_handle_construct (GType object_type, EaseHandlePosition pos) {
#line 108 "ease-handle.c"
	EaseHandle * self;
	char* _tmp1_;
	char* _tmp0_;
	self = g_object_newv (object_type, 0, NULL);
#line 53 "ease-handle.vala"
	self->priv->position = pos;
#line 56 "ease-handle.vala"
	g_object_set ((ClutterTexture*) self, "filename", _tmp1_ = ease_data_path (_tmp0_ = g_build_filename (EASE_TEMP_IMG_DIR, EASE_HANDLE_W_PATH, NULL)), NULL);
#line 117 "ease-handle.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 59 "ease-handle.vala"
	clutter_actor_set_anchor_point ((ClutterActor*) self, clutter_actor_get_width ((ClutterActor*) self) / 2, clutter_actor_get_height ((ClutterActor*) self) / 2);
#line 62 "ease-handle.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 124 "ease-handle.c"
	return self;
}


#line 50 "ease-handle.vala"
EaseHandle* ease_handle_new (EaseHandlePosition pos) {
#line 50 "ease-handle.vala"
	return ease_handle_construct (EASE_TYPE_HANDLE, pos);
#line 133 "ease-handle.c"
}


#line 74 "ease-handle.vala"
void ease_handle_drag (EaseHandle* self, float change_x, float change_y, EaseActor* target, gboolean prop) {
#line 74 "ease-handle.vala"
	g_return_if_fail (self != NULL);
#line 74 "ease-handle.vala"
	g_return_if_fail (target != NULL);
#line 76 "ease-handle.vala"
	switch (self->priv->position) {
#line 145 "ease-handle.c"
		case EASE_HANDLE_POSITION_TOP_LEFT:
		{
#line 79 "ease-handle.vala"
			ease_actor_translate (target, change_x, change_y);
#line 80 "ease-handle.vala"
			ease_actor_resize (target, -change_x, -change_y, prop);
#line 81 "ease-handle.vala"
			break;
#line 154 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_TOP_RIGHT:
		{
#line 84 "ease-handle.vala"
			ease_actor_translate (target, (float) 0, change_y);
#line 85 "ease-handle.vala"
			ease_actor_resize (target, change_x, -change_y, prop);
#line 86 "ease-handle.vala"
			break;
#line 164 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_TOP:
		{
#line 89 "ease-handle.vala"
			ease_actor_translate (target, (float) 0, change_y);
#line 90 "ease-handle.vala"
			ease_actor_resize (target, (float) 0, -change_y, FALSE);
#line 91 "ease-handle.vala"
			break;
#line 174 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM:
		{
#line 94 "ease-handle.vala"
			ease_actor_resize (target, (float) 0, change_y, FALSE);
#line 95 "ease-handle.vala"
			break;
#line 182 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_LEFT:
		{
#line 98 "ease-handle.vala"
			ease_actor_translate (target, change_x, (float) 0);
#line 99 "ease-handle.vala"
			ease_actor_resize (target, -change_x, (float) 0, FALSE);
#line 100 "ease-handle.vala"
			break;
#line 192 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_RIGHT:
		{
#line 103 "ease-handle.vala"
			ease_actor_resize (target, change_x, (float) 0, FALSE);
#line 104 "ease-handle.vala"
			break;
#line 200 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM_LEFT:
		{
#line 107 "ease-handle.vala"
			ease_actor_translate (target, change_x, (float) 0);
#line 108 "ease-handle.vala"
			ease_actor_resize (target, -change_x, change_y, prop);
#line 109 "ease-handle.vala"
			break;
#line 210 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM_RIGHT:
		{
#line 112 "ease-handle.vala"
			ease_actor_resize (target, change_x, change_y, prop);
#line 113 "ease-handle.vala"
			break;
#line 218 "ease-handle.c"
		}
	}
}


#line 126 "ease-handle.vala"
void ease_handle_drag_from_center (EaseHandle* self, float change_x, float change_y, EaseActor* target, gboolean prop) {
#line 126 "ease-handle.vala"
	g_return_if_fail (self != NULL);
#line 126 "ease-handle.vala"
	g_return_if_fail (target != NULL);
#line 129 "ease-handle.vala"
	switch (self->priv->position) {
#line 232 "ease-handle.c"
		case EASE_HANDLE_POSITION_TOP_LEFT:
		{
#line 132 "ease-handle.vala"
			ease_actor_translate (target, change_x, change_y);
#line 133 "ease-handle.vala"
			ease_actor_resize (target, (-change_x) * 2, (-change_y) * 2, FALSE);
#line 134 "ease-handle.vala"
			break;
#line 241 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_TOP_RIGHT:
		{
#line 137 "ease-handle.vala"
			ease_actor_translate (target, -change_x, change_y);
#line 138 "ease-handle.vala"
			ease_actor_resize (target, change_x * 2, (-change_y) * 2, prop);
#line 139 "ease-handle.vala"
			break;
#line 251 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_TOP:
		{
#line 142 "ease-handle.vala"
			ease_actor_translate (target, (float) 0, change_y);
#line 143 "ease-handle.vala"
			ease_actor_resize (target, (float) 0, (-change_y) * 2, FALSE);
#line 144 "ease-handle.vala"
			break;
#line 261 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM:
		{
#line 147 "ease-handle.vala"
			ease_actor_translate (target, (float) 0, -change_y);
#line 148 "ease-handle.vala"
			ease_actor_resize (target, (float) 0, change_y * 2, FALSE);
#line 149 "ease-handle.vala"
			break;
#line 271 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_LEFT:
		{
#line 152 "ease-handle.vala"
			ease_actor_translate (target, change_x, (float) 0);
#line 153 "ease-handle.vala"
			ease_actor_resize (target, (-change_x) * 2, (float) 0, FALSE);
#line 154 "ease-handle.vala"
			break;
#line 281 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_RIGHT:
		{
#line 157 "ease-handle.vala"
			ease_actor_translate (target, -change_x, (float) 0);
#line 158 "ease-handle.vala"
			ease_actor_resize (target, change_x * 2, (float) 0, FALSE);
#line 159 "ease-handle.vala"
			break;
#line 291 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM_LEFT:
		{
#line 162 "ease-handle.vala"
			ease_actor_translate (target, change_x, -change_y);
#line 163 "ease-handle.vala"
			ease_actor_resize (target, (-change_x) * 2, change_y * 2, prop);
#line 164 "ease-handle.vala"
			break;
#line 301 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM_RIGHT:
		{
#line 167 "ease-handle.vala"
			ease_actor_translate (target, -change_x, -change_y);
#line 168 "ease-handle.vala"
			ease_actor_resize (target, change_x * 2, change_y * 2, prop);
#line 169 "ease-handle.vala"
			break;
#line 311 "ease-handle.c"
		}
	}
}


#line 179 "ease-handle.vala"
void ease_handle_reposition (EaseHandle* self, ClutterActor* selection) {
#line 179 "ease-handle.vala"
	g_return_if_fail (self != NULL);
#line 179 "ease-handle.vala"
	g_return_if_fail (selection != NULL);
#line 181 "ease-handle.vala"
	switch (self->priv->position) {
#line 325 "ease-handle.c"
		case EASE_HANDLE_POSITION_TOP_LEFT:
		{
#line 184 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection));
#line 185 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection));
#line 186 "ease-handle.vala"
			break;
#line 334 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_TOP_RIGHT:
		{
#line 189 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection) + clutter_actor_get_width (selection));
#line 190 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection));
#line 191 "ease-handle.vala"
			break;
#line 344 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_TOP:
		{
#line 194 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection) + (clutter_actor_get_width (selection) / 2));
#line 195 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection));
#line 196 "ease-handle.vala"
			break;
#line 354 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_LEFT:
		{
#line 199 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection));
#line 200 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection) + (clutter_actor_get_height (selection) / 2));
#line 201 "ease-handle.vala"
			break;
#line 364 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_RIGHT:
		{
#line 204 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection) + clutter_actor_get_width (selection));
#line 205 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection) + (clutter_actor_get_height (selection) / 2));
#line 206 "ease-handle.vala"
			break;
#line 374 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM_LEFT:
		{
#line 209 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection));
#line 210 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection) + clutter_actor_get_height (selection));
#line 211 "ease-handle.vala"
			break;
#line 384 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM_RIGHT:
		{
#line 214 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection) + clutter_actor_get_width (selection));
#line 215 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection) + clutter_actor_get_height (selection));
#line 216 "ease-handle.vala"
			break;
#line 394 "ease-handle.c"
		}
		case EASE_HANDLE_POSITION_BOTTOM:
		{
#line 219 "ease-handle.vala"
			clutter_actor_set_x ((ClutterActor*) self, clutter_actor_get_x (selection) + (clutter_actor_get_width (selection) / 2));
#line 220 "ease-handle.vala"
			clutter_actor_set_y ((ClutterActor*) self, clutter_actor_get_y (selection) + clutter_actor_get_height (selection));
#line 221 "ease-handle.vala"
			break;
#line 404 "ease-handle.c"
		}
	}
}


#line 228 "ease-handle.vala"
void ease_handle_flip (EaseHandle* self) {
#line 228 "ease-handle.vala"
	g_return_if_fail (self != NULL);
#line 230 "ease-handle.vala"
	if (self->priv->flipped) {
#line 416 "ease-handle.c"
		char* _tmp1_;
		char* _tmp0_;
#line 232 "ease-handle.vala"
		g_object_set ((ClutterTexture*) self, "filename", _tmp1_ = ease_data_path (_tmp0_ = g_build_filename (EASE_TEMP_IMG_DIR, EASE_HANDLE_W_PATH, NULL)), NULL);
#line 421 "ease-handle.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
	} else {
		char* _tmp3_;
		char* _tmp2_;
#line 236 "ease-handle.vala"
		g_object_set ((ClutterTexture*) self, "filename", _tmp3_ = ease_data_path (_tmp2_ = g_build_filename (EASE_TEMP_IMG_DIR, EASE_HANDLE_B_PATH, NULL)), NULL);
#line 429 "ease-handle.c"
		_g_free0 (_tmp3_);
		_g_free0 (_tmp2_);
	}
#line 239 "ease-handle.vala"
	self->priv->flipped = !self->priv->flipped;
#line 435 "ease-handle.c"
}


static void ease_handle_class_init (EaseHandleClass * klass) {
	ease_handle_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (EaseHandlePrivate));
	G_OBJECT_CLASS (klass)->finalize = ease_handle_finalize;
}


static void ease_handle_instance_init (EaseHandle * self) {
	self->priv = EASE_HANDLE_GET_PRIVATE (self);
	self->priv->flipped = FALSE;
}


static void ease_handle_finalize (GObject* obj) {
	EaseHandle * self;
	self = EASE_HANDLE (obj);
	G_OBJECT_CLASS (ease_handle_parent_class)->finalize (obj);
}


GType ease_handle_get_type (void) {
	static volatile gsize ease_handle_type_id__volatile = 0;
	if (g_once_init_enter (&ease_handle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EaseHandleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_handle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EaseHandle), 0, (GInstanceInitFunc) ease_handle_instance_init, NULL };
		GType ease_handle_type_id;
		ease_handle_type_id = g_type_register_static (CLUTTER_TYPE_TEXTURE, "EaseHandle", &g_define_type_info, 0);
		g_once_init_leave (&ease_handle_type_id__volatile, ease_handle_type_id);
	}
	return ease_handle_type_id__volatile;
}




