/* ease-player.c generated by valac, the Vala compiler
 * generated from ease-player.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gee.h>


#define EASE_TYPE_PLAYER (ease_player_get_type ())
#define EASE_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_PLAYER, EasePlayer))
#define EASE_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_PLAYER, EasePlayerClass))
#define EASE_IS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_PLAYER))
#define EASE_IS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_PLAYER))
#define EASE_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_PLAYER, EasePlayerClass))

typedef struct _EasePlayer EasePlayer;
typedef struct _EasePlayerClass EasePlayerClass;
typedef struct _EasePlayerPrivate EasePlayerPrivate;

#define EASE_TYPE_SLIDE_SET (ease_slide_set_get_type ())
#define EASE_SLIDE_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_SLIDE_SET, EaseSlideSet))
#define EASE_SLIDE_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_SLIDE_SET, EaseSlideSetClass))
#define EASE_IS_SLIDE_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_SLIDE_SET))
#define EASE_IS_SLIDE_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_SLIDE_SET))
#define EASE_SLIDE_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_SLIDE_SET, EaseSlideSetClass))

typedef struct _EaseSlideSet EaseSlideSet;
typedef struct _EaseSlideSetClass EaseSlideSetClass;

#define EASE_TYPE_DOCUMENT (ease_document_get_type ())
#define EASE_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_DOCUMENT, EaseDocument))
#define EASE_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_DOCUMENT, EaseDocumentClass))
#define EASE_IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_DOCUMENT))
#define EASE_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_DOCUMENT))
#define EASE_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_DOCUMENT, EaseDocumentClass))

typedef struct _EaseDocument EaseDocument;
typedef struct _EaseDocumentClass EaseDocumentClass;

#define EASE_TYPE_SLIDE_ACTOR (ease_slide_actor_get_type ())
#define EASE_SLIDE_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_SLIDE_ACTOR, EaseSlideActor))
#define EASE_SLIDE_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_SLIDE_ACTOR, EaseSlideActorClass))
#define EASE_IS_SLIDE_ACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_SLIDE_ACTOR))
#define EASE_IS_SLIDE_ACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_SLIDE_ACTOR))
#define EASE_SLIDE_ACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_SLIDE_ACTOR, EaseSlideActorClass))

typedef struct _EaseSlideActor EaseSlideActor;
typedef struct _EaseSlideActorClass EaseSlideActorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _EaseSlideSetPrivate EaseSlideSetPrivate;

#define EASE_TYPE_SLIDE (ease_slide_get_type ())
#define EASE_SLIDE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_SLIDE, EaseSlide))
#define EASE_SLIDE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_SLIDE, EaseSlideClass))
#define EASE_IS_SLIDE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_SLIDE))
#define EASE_IS_SLIDE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_SLIDE))
#define EASE_SLIDE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_SLIDE, EaseSlideClass))

typedef struct _EaseSlide EaseSlide;
typedef struct _EaseSlideClass EaseSlideClass;

#define EASE_TYPE_ACTOR_CONTEXT (ease_actor_context_get_type ())

struct _EasePlayer {
	GObject parent_instance;
	EasePlayerPrivate * priv;
};

struct _EasePlayerClass {
	GObjectClass parent_class;
};

struct _EasePlayerPrivate {
	EaseDocument* _document;
	gint _slide_index;
	ClutterStage* _stage;
	gboolean _can_animate;
	gboolean dragging;
	EaseSlideActor* current_slide;
	EaseSlideActor* old_slide;
	ClutterGroup* container;
	ClutterTimeline* advance_alarm;
	float scale;
	ClutterGroup* shader;
	ClutterRectangle* shader_top;
	ClutterRectangle* shader_bottom;
	ClutterRectangle* shader_left;
	ClutterRectangle* shader_right;
};

struct _EaseSlideSet {
	GObject parent_instance;
	EaseSlideSetPrivate * priv;
	GeeArrayList* slides;
};

struct _EaseSlideSetClass {
	GObjectClass parent_class;
	void (*add_slide) (EaseSlideSet* self, gint index, EaseSlide* s);
};

typedef enum  {
	EASE_ACTOR_CONTEXT_PRESENTATION,
	EASE_ACTOR_CONTEXT_EDITOR,
	EASE_ACTOR_CONTEXT_INSPECTOR
} EaseActorContext;


static gpointer ease_player_parent_class = NULL;

GType ease_player_get_type (void) G_GNUC_CONST;
GType ease_slide_set_get_type (void) G_GNUC_CONST;
GType ease_document_get_type (void) G_GNUC_CONST;
GType ease_slide_actor_get_type (void) G_GNUC_CONST;
#define EASE_PLAYER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), EASE_TYPE_PLAYER, EasePlayerPrivate))
enum  {
	EASE_PLAYER_DUMMY_PROPERTY,
	EASE_PLAYER_DOCUMENT,
	EASE_PLAYER_SLIDE_INDEX,
	EASE_PLAYER_STAGE
};
#define EASE_PLAYER_FADE_IN_TIME ((guint) 1000)
#define EASE_PLAYER_FOCUS_OPACITY ((guint) 100)
#define EASE_PLAYER_FOCUS_RADIUS ((guint) 40)
void ease_player_set_document (EasePlayer* self, EaseDocument* value);
void ease_player_set_slide_index (EasePlayer* self, gint value);
void ease_player_set_stage (EasePlayer* self, ClutterStage* value);
EaseDocument* ease_player_get_document (EasePlayer* self);
gint ease_document_get_width (EaseDocument* self);
ClutterStage* ease_player_get_stage (EasePlayer* self);
gint ease_document_get_height (EaseDocument* self);
void ease_player_on_key_press (EasePlayer* self, ClutterKeyEvent* event);
static gboolean _lambda42_ (ClutterKeyEvent* ev, EasePlayer* self);
static gboolean __lambda42__clutter_actor_key_press_event (ClutterActor* _sender, ClutterKeyEvent* event, gpointer self);
void ease_player_on_button_press (EasePlayer* self, ClutterButtonEvent* event);
static gboolean _lambda44_ (ClutterButtonEvent* ev, EasePlayer* self);
static gboolean __lambda44__clutter_actor_button_press_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self);
void ease_player_on_motion (EasePlayer* self, ClutterMotionEvent* event);
static gboolean _lambda45_ (ClutterMotionEvent* ev, EasePlayer* self);
static gboolean __lambda45__clutter_actor_motion_event (ClutterActor* _sender, ClutterMotionEvent* event, gpointer self);
void ease_player_on_button_release (EasePlayer* self, ClutterButtonEvent* event);
static gboolean _lambda46_ (ClutterButtonEvent* ev, EasePlayer* self);
static gboolean __lambda46__clutter_actor_button_release_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self);
static void ease_player_set_can_animate (EasePlayer* self, gboolean value);
void ease_player_advance (EasePlayer* self);
EasePlayer* ease_player_new (EaseDocument* doc);
EasePlayer* ease_player_construct (GType object_type, EaseDocument* doc);
static void ease_player_retreat (EasePlayer* self);
static gboolean ease_player_get_can_animate (EasePlayer* self);
gint ease_player_get_slide_index (EasePlayer* self);
GType ease_slide_get_type (void) G_GNUC_CONST;
static void ease_player_create_current_slide (EasePlayer* self, EaseSlide* slide);
void ease_slide_actor_stack (EaseSlideActor* self, ClutterActor* container);
static void ease_player_animation_complete (EasePlayer* self);
static void _ease_player_animation_complete_clutter_timeline_completed (ClutterTimeline* _sender, gpointer self);
EaseSlide* ease_slide_actor_get_slide (EaseSlideActor* self);
double ease_slide_get_transition_time (EaseSlide* self);
void ease_slide_actor_transition (EaseSlideActor* self, EaseSlideActor* new_slide, ClutterGroup* container);
ClutterTimeline* ease_slide_actor_get_animation_time (EaseSlideActor* self);
GType ease_actor_context_get_type (void) G_GNUC_CONST;
EaseSlideActor* ease_slide_actor_new_from_slide (EaseDocument* document, EaseSlide* s, gboolean clip, EaseActorContext ctx);
EaseSlideActor* ease_slide_actor_construct_from_slide (GType object_type, EaseDocument* document, EaseSlide* s, gboolean clip, EaseActorContext ctx);
gboolean ease_slide_get_automatically_advance (EaseSlide* self);
double ease_slide_get_advance_delay (EaseSlide* self);
static void _lambda43_ (EasePlayer* self);
static void __lambda43__clutter_timeline_completed (ClutterTimeline* _sender, gpointer self);
static void ease_player_finalize (GObject* obj);
static void ease_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void ease_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 77 "ease-player.vala"
static gboolean _lambda42_ (ClutterKeyEvent* ev, EasePlayer* self) {
#line 197 "ease-player.c"
	gboolean result = FALSE;
#line 79 "ease-player.vala"
	ease_player_on_key_press (self, ev);
#line 201 "ease-player.c"
	result = TRUE;
#line 80 "ease-player.vala"
	return result;
#line 205 "ease-player.c"
}


#line 77 "ease-player.vala"
static gboolean __lambda42__clutter_actor_key_press_event (ClutterActor* _sender, ClutterKeyEvent* event, gpointer self) {
#line 211 "ease-player.c"
	gboolean result;
	result = _lambda42_ (event, self);
	return result;
}


#line 84 "ease-player.vala"
static gboolean _lambda44_ (ClutterButtonEvent* ev, EasePlayer* self) {
#line 220 "ease-player.c"
	gboolean result = FALSE;
#line 86 "ease-player.vala"
	ease_player_on_button_press (self, ev);
#line 224 "ease-player.c"
	result = TRUE;
#line 87 "ease-player.vala"
	return result;
#line 228 "ease-player.c"
}


#line 84 "ease-player.vala"
static gboolean __lambda44__clutter_actor_button_press_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self) {
#line 234 "ease-player.c"
	gboolean result;
	result = _lambda44_ (event, self);
	return result;
}


#line 90 "ease-player.vala"
static gboolean _lambda45_ (ClutterMotionEvent* ev, EasePlayer* self) {
#line 243 "ease-player.c"
	gboolean result = FALSE;
#line 92 "ease-player.vala"
	ease_player_on_motion (self, ev);
#line 247 "ease-player.c"
	result = TRUE;
#line 93 "ease-player.vala"
	return result;
#line 251 "ease-player.c"
}


#line 90 "ease-player.vala"
static gboolean __lambda45__clutter_actor_motion_event (ClutterActor* _sender, ClutterMotionEvent* event, gpointer self) {
#line 257 "ease-player.c"
	gboolean result;
	result = _lambda45_ (event, self);
	return result;
}


#line 96 "ease-player.vala"
static gboolean _lambda46_ (ClutterButtonEvent* ev, EasePlayer* self) {
#line 266 "ease-player.c"
	gboolean result = FALSE;
#line 98 "ease-player.vala"
	ease_player_on_button_release (self, ev);
#line 270 "ease-player.c"
	result = TRUE;
#line 99 "ease-player.vala"
	return result;
#line 274 "ease-player.c"
}


#line 96 "ease-player.vala"
static gboolean __lambda46__clutter_actor_button_release_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self) {
#line 280 "ease-player.c"
	gboolean result;
	result = _lambda46_ (event, self);
	return result;
}


#line 56 "ease-player.vala"
EasePlayer* ease_player_construct (GType object_type, EaseDocument* doc) {
#line 289 "ease-player.c"
	EasePlayer * self;
	ClutterStage* _tmp0_;
	gboolean _tmp1_ = FALSE;
	ClutterColor _tmp3_ = {0};
	ClutterColor _tmp4_;
	ClutterRectangle* _tmp7_;
	ClutterColor _tmp6_;
	ClutterColor _tmp5_ = {0};
	ClutterRectangle* _tmp10_;
	ClutterColor _tmp9_;
	ClutterColor _tmp8_ = {0};
	ClutterRectangle* _tmp13_;
	ClutterColor _tmp12_;
	ClutterColor _tmp11_ = {0};
	ClutterRectangle* _tmp16_;
	ClutterColor _tmp15_;
	ClutterColor _tmp14_ = {0};
	ClutterGroup* _tmp17_;
	ClutterGroup* _tmp18_;
#line 56 "ease-player.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 56 "ease-player.vala"
	self = (EasePlayer*) g_object_new (object_type, NULL);
#line 58 "ease-player.vala"
	ease_player_set_document (self, doc);
#line 59 "ease-player.vala"
	ease_player_set_slide_index (self, -1);
#line 61 "ease-player.vala"
	ease_player_set_stage (self, _tmp0_ = g_object_ref_sink ((ClutterStage*) clutter_stage_new ()));
#line 319 "ease-player.c"
	_g_object_unref0 (_tmp0_);
#line 62 "ease-player.vala"
	clutter_actor_set_width ((ClutterActor*) self->priv->_stage, ease_document_get_width (self->priv->_document) * self->priv->scale);
#line 63 "ease-player.vala"
	clutter_actor_set_height ((ClutterActor*) self->priv->_stage, ease_document_get_height (self->priv->_document) * self->priv->scale);
#line 64 "ease-player.vala"
	clutter_stage_set_title (self->priv->_stage, _ ("Ease Presentation"));
#line 65 "ease-player.vala"
	clutter_stage_set_use_fog (self->priv->_stage, FALSE);
#line 68 "ease-player.vala"
	if (clutter_actor_get_width ((ClutterActor*) self->priv->_stage) < ease_document_get_width (self->priv->_document)) {
#line 68 "ease-player.vala"
		_tmp1_ = TRUE;
#line 333 "ease-player.c"
	} else {
#line 68 "ease-player.vala"
		_tmp1_ = clutter_actor_get_height ((ClutterActor*) self->priv->_stage) < ease_document_get_height (self->priv->_document);
#line 337 "ease-player.c"
	}
#line 68 "ease-player.vala"
	if (_tmp1_) {
#line 341 "ease-player.c"
		float x;
		float y;
		float _tmp2_ = 0.0F;
#line 70 "ease-player.vala"
		x = ((float) clutter_actor_get_width ((ClutterActor*) self->priv->_stage)) / ease_document_get_width (self->priv->_document);
#line 71 "ease-player.vala"
		y = ((float) clutter_actor_get_height ((ClutterActor*) self->priv->_stage)) / ease_document_get_height (self->priv->_document);
#line 73 "ease-player.vala"
		if (x < y) {
#line 73 "ease-player.vala"
			_tmp2_ = x;
#line 353 "ease-player.c"
		} else {
#line 73 "ease-player.vala"
			_tmp2_ = y;
#line 357 "ease-player.c"
		}
#line 73 "ease-player.vala"
		self->priv->scale = _tmp2_;
#line 361 "ease-player.c"
	}
#line 77 "ease-player.vala"
	g_signal_connect_object ((ClutterActor*) self->priv->_stage, "key-press-event", (GCallback) __lambda42__clutter_actor_key_press_event, self, 0);
#line 84 "ease-player.vala"
	g_signal_connect_object ((ClutterActor*) self->priv->_stage, "button-press-event", (GCallback) __lambda44__clutter_actor_button_press_event, self, 0);
#line 90 "ease-player.vala"
	g_signal_connect_object ((ClutterActor*) self->priv->_stage, "motion-event", (GCallback) __lambda45__clutter_actor_motion_event, self, 0);
#line 96 "ease-player.vala"
	g_signal_connect_object ((ClutterActor*) self->priv->_stage, "button-release-event", (GCallback) __lambda46__clutter_actor_button_release_event, self, 0);
#line 106 "ease-player.vala"
	clutter_stage_set_color (self->priv->_stage, (_tmp4_ = (_tmp3_.red = (guchar) 0, _tmp3_.green = (guchar) 0, _tmp3_.blue = (guchar) 0, _tmp3_.alpha = (guchar) 255, _tmp3_), &_tmp4_));
#line 107 "ease-player.vala"
	clutter_grab_keyboard ((ClutterActor*) self->priv->_stage);
#line 110 "ease-player.vala"
	self->priv->shader_top = (_tmp7_ = g_object_ref_sink ((ClutterRectangle*) clutter_rectangle_new_with_color ((_tmp6_ = (clutter_color_from_string (&_tmp5_, "black"), _tmp5_), &_tmp6_))), _g_object_unref0 (self->priv->shader_top), _tmp7_);
#line 111 "ease-player.vala"
	self->priv->shader_right = (_tmp10_ = g_object_ref_sink ((ClutterRectangle*) clutter_rectangle_new_with_color ((_tmp9_ = (clutter_color_from_string (&_tmp8_, "black"), _tmp8_), &_tmp9_))), _g_object_unref0 (self->priv->shader_right), _tmp10_);
#line 112 "ease-player.vala"
	self->priv->shader_bottom = (_tmp13_ = g_object_ref_sink ((ClutterRectangle*) clutter_rectangle_new_with_color ((_tmp12_ = (clutter_color_from_string (&_tmp11_, "black"), _tmp11_), &_tmp12_))), _g_object_unref0 (self->priv->shader_bottom), _tmp13_);
#line 113 "ease-player.vala"
	self->priv->shader_left = (_tmp16_ = g_object_ref_sink ((ClutterRectangle*) clutter_rectangle_new_with_color ((_tmp15_ = (clutter_color_from_string (&_tmp14_, "black"), _tmp14_), &_tmp15_))), _g_object_unref0 (self->priv->shader_left), _tmp16_);
#line 115 "ease-player.vala"
	self->priv->shader = (_tmp17_ = g_object_ref_sink ((ClutterGroup*) clutter_group_new ()), _g_object_unref0 (self->priv->shader), _tmp17_);
#line 116 "ease-player.vala"
	clutter_actor_set_opacity ((ClutterActor*) self->priv->shader, (guint) 0);
#line 122 "ease-player.vala"
	clutter_container_add ((ClutterContainer*) self->priv->shader, self->priv->shader_top, self->priv->shader_right, self->priv->shader_bottom, self->priv->shader_left, NULL);
#line 127 "ease-player.vala"
	clutter_container_add ((ClutterContainer*) self->priv->_stage, self->priv->shader, NULL);
#line 130 "ease-player.vala"
	self->priv->container = (_tmp18_ = g_object_ref_sink ((ClutterGroup*) clutter_group_new ()), _g_object_unref0 (self->priv->container), _tmp18_);
#line 131 "ease-player.vala"
	clutter_container_add_actor ((ClutterContainer*) self->priv->_stage, (ClutterActor*) self->priv->container);
#line 132 "ease-player.vala"
	g_object_set ((ClutterActor*) self->priv->container, "scale-x", (double) self->priv->scale, NULL);
#line 133 "ease-player.vala"
	g_object_set ((ClutterActor*) self->priv->container, "scale-y", (double) self->priv->scale, NULL);
#line 136 "ease-player.vala"
	clutter_actor_show_all ((ClutterActor*) self->priv->_stage);
#line 137 "ease-player.vala"
	clutter_stage_set_fullscreen (self->priv->_stage, TRUE);
#line 139 "ease-player.vala"
	ease_player_set_can_animate (self, TRUE);
#line 140 "ease-player.vala"
	ease_player_advance (self);
#line 407 "ease-player.c"
	return self;
}


#line 56 "ease-player.vala"
EasePlayer* ease_player_new (EaseDocument* doc) {
#line 56 "ease-player.vala"
	return ease_player_construct (EASE_TYPE_PLAYER, doc);
#line 416 "ease-player.c"
}


#line 143 "ease-player.vala"
void ease_player_on_motion (EasePlayer* self, ClutterMotionEvent* event) {
#line 143 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 145 "ease-player.vala"
	if (self->priv->dragging) {
#line 147 "ease-player.vala"
		clutter_actor_set_size ((ClutterActor*) self->priv->shader_top, clutter_actor_get_width ((ClutterActor*) self->priv->_stage), (*event).y - EASE_PLAYER_FOCUS_RADIUS);
#line 148 "ease-player.vala"
		clutter_actor_set_size ((ClutterActor*) self->priv->shader_bottom, clutter_actor_get_width ((ClutterActor*) self->priv->_stage), (clutter_actor_get_height ((ClutterActor*) self->priv->_stage) - (*event).y) - EASE_PLAYER_FOCUS_RADIUS);
#line 149 "ease-player.vala"
		clutter_actor_set_size ((ClutterActor*) self->priv->shader_left, (*event).x - EASE_PLAYER_FOCUS_RADIUS, (float) (EASE_PLAYER_FOCUS_RADIUS * 2));
#line 150 "ease-player.vala"
		clutter_actor_set_size ((ClutterActor*) self->priv->shader_right, (clutter_actor_get_width ((ClutterActor*) self->priv->_stage) - (*event).x) - EASE_PLAYER_FOCUS_RADIUS, (float) (2 * EASE_PLAYER_FOCUS_RADIUS));
#line 152 "ease-player.vala"
		clutter_actor_set_position ((ClutterActor*) self->priv->shader_left, (float) 0, (*event).y - EASE_PLAYER_FOCUS_RADIUS);
#line 153 "ease-player.vala"
		clutter_actor_set_position ((ClutterActor*) self->priv->shader_right, (*event).x + EASE_PLAYER_FOCUS_RADIUS, (*event).y - EASE_PLAYER_FOCUS_RADIUS);
#line 154 "ease-player.vala"
		clutter_actor_set_position ((ClutterActor*) self->priv->shader_bottom, (float) 0, (*event).y + EASE_PLAYER_FOCUS_RADIUS);
#line 155 "ease-player.vala"
		clutter_actor_show_all ((ClutterActor*) self->priv->shader);
#line 156 "ease-player.vala"
		clutter_container_raise_child ((ClutterContainer*) self->priv->_stage, (ClutterActor*) self->priv->shader, NULL);
#line 444 "ease-player.c"
	} else {
	}
}


#line 162 "ease-player.vala"
void ease_player_on_button_release (EasePlayer* self, ClutterButtonEvent* event) {
#line 162 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 164 "ease-player.vala"
	self->priv->dragging = FALSE;
#line 166 "ease-player.vala"
	clutter_actor_animate ((ClutterActor*) self->priv->shader, (gulong) CLUTTER_LINEAR, (guint) 150, "opacity", 0, NULL);
#line 458 "ease-player.c"
}


#line 170 "ease-player.vala"
void ease_player_on_button_press (EasePlayer* self, ClutterButtonEvent* event) {
#line 170 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 172 "ease-player.vala"
	self->priv->dragging = TRUE;
#line 173 "ease-player.vala"
	g_debug ("ease-player.vala:173: Got a mouse click at %f, %f", (double) (*event).x, (double) (*event).y);
#line 174 "ease-player.vala"
	clutter_actor_set_size ((ClutterActor*) self->priv->shader_top, clutter_actor_get_width ((ClutterActor*) self->priv->_stage), (*event).y - EASE_PLAYER_FOCUS_RADIUS);
#line 175 "ease-player.vala"
	clutter_actor_set_size ((ClutterActor*) self->priv->shader_bottom, clutter_actor_get_width ((ClutterActor*) self->priv->_stage), (clutter_actor_get_height ((ClutterActor*) self->priv->_stage) - (*event).y) - EASE_PLAYER_FOCUS_RADIUS);
#line 176 "ease-player.vala"
	clutter_actor_set_size ((ClutterActor*) self->priv->shader_left, (*event).x - EASE_PLAYER_FOCUS_RADIUS, (float) (EASE_PLAYER_FOCUS_RADIUS * 2));
#line 177 "ease-player.vala"
	clutter_actor_set_size ((ClutterActor*) self->priv->shader_right, (clutter_actor_get_width ((ClutterActor*) self->priv->_stage) - (*event).x) - EASE_PLAYER_FOCUS_RADIUS, (float) (2 * EASE_PLAYER_FOCUS_RADIUS));
#line 179 "ease-player.vala"
	clutter_actor_set_position ((ClutterActor*) self->priv->shader_left, (float) 0, (*event).y - EASE_PLAYER_FOCUS_RADIUS);
#line 180 "ease-player.vala"
	clutter_actor_set_position ((ClutterActor*) self->priv->shader_right, (*event).x + EASE_PLAYER_FOCUS_RADIUS, (*event).y - EASE_PLAYER_FOCUS_RADIUS);
#line 181 "ease-player.vala"
	clutter_actor_set_position ((ClutterActor*) self->priv->shader_bottom, (float) 0, (*event).y + EASE_PLAYER_FOCUS_RADIUS);
#line 182 "ease-player.vala"
	clutter_actor_show_all ((ClutterActor*) self->priv->shader);
#line 183 "ease-player.vala"
	clutter_container_raise_child ((ClutterContainer*) self->priv->_stage, (ClutterActor*) self->priv->shader, NULL);
#line 184 "ease-player.vala"
	clutter_actor_animate ((ClutterActor*) self->priv->shader, (gulong) CLUTTER_LINEAR, (guint) 150, "opacity", EASE_PLAYER_FOCUS_OPACITY, NULL);
#line 490 "ease-player.c"
}


#line 188 "ease-player.vala"
void ease_player_on_key_press (EasePlayer* self, ClutterKeyEvent* event) {
#line 188 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 192 "ease-player.vala"
	g_debug ("ease-player.vala:192: Got a key press, keyval = %u", (*event).keyval);
#line 193 "ease-player.vala"
	switch ((*event).keyval) {
#line 502 "ease-player.c"
		case 0xff1b:
		{
#line 196 "ease-player.vala"
			g_debug ("ease-player.vala:196: Quitting player.");
#line 197 "ease-player.vala"
			clutter_actor_hide ((ClutterActor*) self->priv->_stage);
#line 198 "ease-player.vala"
			break;
#line 511 "ease-player.c"
		}
		case 0xff53:
		{
#line 201 "ease-player.vala"
			g_debug ("ease-player.vala:201: Advancing to next slide.");
#line 202 "ease-player.vala"
			ease_player_advance (self);
#line 203 "ease-player.vala"
			break;
#line 521 "ease-player.c"
		}
		case 0xff51:
		{
#line 206 "ease-player.vala"
			g_debug ("ease-player.vala:206: Retreating to previous slide");
#line 207 "ease-player.vala"
			ease_player_retreat (self);
#line 208 "ease-player.vala"
			break;
#line 531 "ease-player.c"
		}
		default:
		{
#line 210 "ease-player.vala"
			g_debug ("ease-player.vala:210: Key not handled.");
#line 211 "ease-player.vala"
			break;
#line 539 "ease-player.c"
		}
	}
}


#line 302 "ease-player.vala"
static void _ease_player_animation_complete_clutter_timeline_completed (ClutterTimeline* _sender, gpointer self) {
#line 547 "ease-player.c"
	ease_player_animation_complete (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 215 "ease-player.vala"
void ease_player_advance (EasePlayer* self) {
#line 559 "ease-player.c"
	gint _tmp1_;
	EaseSlide* slide;
#line 215 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 218 "ease-player.vala"
	if (!self->priv->_can_animate) {
#line 220 "ease-player.vala"
		return;
#line 568 "ease-player.c"
	}
#line 224 "ease-player.vala"
	if (self->priv->advance_alarm != NULL) {
#line 572 "ease-player.c"
		ClutterTimeline* _tmp0_;
#line 226 "ease-player.vala"
		clutter_timeline_stop (self->priv->advance_alarm);
#line 227 "ease-player.vala"
		self->priv->advance_alarm = (_tmp0_ = NULL, _g_object_unref0 (self->priv->advance_alarm), _tmp0_);
#line 578 "ease-player.c"
	}
#line 230 "ease-player.vala"
	_tmp1_ = self->priv->_slide_index;
#line 230 "ease-player.vala"
	ease_player_set_slide_index (self, _tmp1_ + 1);
#line 230 "ease-player.vala"
	_tmp1_;
#line 231 "ease-player.vala"
	if (self->priv->_slide_index == gee_collection_get_size ((GeeCollection*) ((EaseSlideSet*) self->priv->_document)->slides)) {
#line 233 "ease-player.vala"
		clutter_actor_hide_all ((ClutterActor*) self->priv->_stage);
#line 234 "ease-player.vala"
		return;
#line 592 "ease-player.c"
	}
#line 237 "ease-player.vala"
	slide = (EaseSlide*) gee_abstract_list_get ((GeeAbstractList*) ((EaseSlideSet*) self->priv->_document)->slides, self->priv->_slide_index);
#line 240 "ease-player.vala"
	if (self->priv->_slide_index == 0) {
#line 598 "ease-player.c"
		ClutterTimeline* _tmp2_;
#line 242 "ease-player.vala"
		ease_player_create_current_slide (self, slide);
#line 243 "ease-player.vala"
		ease_slide_actor_stack (self->priv->current_slide, (ClutterActor*) self->priv->container);
#line 244 "ease-player.vala"
		clutter_actor_set_opacity ((ClutterActor*) self->priv->current_slide, (guint) 0);
#line 245 "ease-player.vala"
		clutter_actor_animate ((ClutterActor*) self->priv->current_slide, (gulong) CLUTTER_EASE_IN_SINE, EASE_PLAYER_FADE_IN_TIME, "opacity", 255, NULL);
#line 248 "ease-player.vala"
		self->priv->advance_alarm = (_tmp2_ = clutter_timeline_new (EASE_PLAYER_FADE_IN_TIME), _g_object_unref0 (self->priv->advance_alarm), _tmp2_);
#line 249 "ease-player.vala"
		g_signal_connect_object (self->priv->advance_alarm, "completed", (GCallback) _ease_player_animation_complete_clutter_timeline_completed, self, 0);
#line 250 "ease-player.vala"
		clutter_timeline_start (self->priv->advance_alarm);
#line 252 "ease-player.vala"
		ease_player_set_can_animate (self, FALSE);
#line 616 "ease-player.c"
	} else {
		EaseSlideActor* _tmp3_;
#line 258 "ease-player.vala"
		self->priv->old_slide = (_tmp3_ = _g_object_ref0 (self->priv->current_slide), _g_object_unref0 (self->priv->old_slide), _tmp3_);
#line 259 "ease-player.vala"
		ease_player_create_current_slide (self, slide);
#line 260 "ease-player.vala"
		clutter_container_add_actor ((ClutterContainer*) self->priv->container, (ClutterActor*) self->priv->current_slide);
#line 262 "ease-player.vala"
		if (ease_slide_get_transition_time (ease_slide_actor_get_slide (self->priv->old_slide)) > 0) {
#line 264 "ease-player.vala"
			ease_slide_actor_transition (self->priv->old_slide, self->priv->current_slide, self->priv->container);
#line 265 "ease-player.vala"
			g_signal_connect_object (ease_slide_actor_get_animation_time (self->priv->old_slide), "completed", (GCallback) _ease_player_animation_complete_clutter_timeline_completed, self, 0);
#line 266 "ease-player.vala"
			ease_player_set_can_animate (self, FALSE);
#line 633 "ease-player.c"
		} else {
#line 270 "ease-player.vala"
			ease_player_animation_complete (self);
#line 637 "ease-player.c"
		}
	}
	_g_object_unref0 (slide);
}


#line 275 "ease-player.vala"
static void ease_player_retreat (EasePlayer* self) {
#line 646 "ease-player.c"
	gint _tmp0_;
	EaseSlide* _tmp1_;
#line 275 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 277 "ease-player.vala"
	if (self->priv->_slide_index == 0) {
#line 278 "ease-player.vala"
		return;
#line 655 "ease-player.c"
	}
#line 281 "ease-player.vala"
	if (ease_slide_actor_get_animation_time (self->priv->old_slide) != NULL) {
#line 282 "ease-player.vala"
		clutter_timeline_stop (ease_slide_actor_get_animation_time (self->priv->old_slide));
#line 661 "ease-player.c"
	}
#line 285 "ease-player.vala"
	_tmp0_ = self->priv->_slide_index;
#line 285 "ease-player.vala"
	ease_player_set_slide_index (self, _tmp0_ - 1);
#line 285 "ease-player.vala"
	_tmp0_;
#line 286 "ease-player.vala"
	ease_player_set_can_animate (self, TRUE);
#line 288 "ease-player.vala"
	clutter_group_remove_all (self->priv->container);
#line 289 "ease-player.vala"
	ease_player_create_current_slide (self, _tmp1_ = (EaseSlide*) gee_abstract_list_get ((GeeAbstractList*) ((EaseSlideSet*) self->priv->_document)->slides, self->priv->_slide_index));
#line 675 "ease-player.c"
	_g_object_unref0 (_tmp1_);
#line 290 "ease-player.vala"
	ease_slide_actor_stack (self->priv->current_slide, (ClutterActor*) self->priv->container);
#line 291 "ease-player.vala"
	clutter_container_add_actor ((ClutterContainer*) self->priv->container, (ClutterActor*) self->priv->current_slide);
#line 681 "ease-player.c"
}


#line 294 "ease-player.vala"
static void ease_player_create_current_slide (EasePlayer* self, EaseSlide* slide) {
#line 687 "ease-player.c"
	EaseSlideActor* _tmp0_;
#line 294 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 294 "ease-player.vala"
	g_return_if_fail (slide != NULL);
#line 298 "ease-player.vala"
	self->priv->current_slide = (_tmp0_ = g_object_ref_sink (ease_slide_actor_new_from_slide (self->priv->_document, slide, TRUE, EASE_ACTOR_CONTEXT_PRESENTATION)), _g_object_unref0 (self->priv->current_slide), _tmp0_);
#line 695 "ease-player.c"
}


#line 315 "ease-player.vala"
static void _lambda43_ (EasePlayer* self) {
#line 316 "ease-player.vala"
	ease_player_advance (self);
#line 703 "ease-player.c"
}


#line 315 "ease-player.vala"
static void __lambda43__clutter_timeline_completed (ClutterTimeline* _sender, gpointer self) {
#line 709 "ease-player.c"
	_lambda43_ (self);
}


#line 302 "ease-player.vala"
static void ease_player_animation_complete (EasePlayer* self) {
#line 302 "ease-player.vala"
	g_return_if_fail (self != NULL);
#line 304 "ease-player.vala"
	clutter_group_remove_all (self->priv->container);
#line 306 "ease-player.vala"
	ease_player_set_can_animate (self, TRUE);
#line 307 "ease-player.vala"
	ease_slide_actor_stack (self->priv->current_slide, (ClutterActor*) self->priv->container);
#line 310 "ease-player.vala"
	if (ease_slide_get_automatically_advance (ease_slide_actor_get_slide (self->priv->current_slide))) {
#line 726 "ease-player.c"
		guint time;
		ClutterTimeline* _tmp0_;
#line 312 "ease-player.vala"
		time = (guint) (1000 * ease_slide_get_advance_delay (ease_slide_actor_get_slide (self->priv->current_slide)));
#line 314 "ease-player.vala"
		self->priv->advance_alarm = (_tmp0_ = clutter_timeline_new (time), _g_object_unref0 (self->priv->advance_alarm), _tmp0_);
#line 315 "ease-player.vala"
		g_signal_connect_object (self->priv->advance_alarm, "completed", (GCallback) __lambda43__clutter_timeline_completed, self, 0);
#line 318 "ease-player.vala"
		clutter_timeline_start (self->priv->advance_alarm);
#line 737 "ease-player.c"
	}
}


EaseDocument* ease_player_get_document (EasePlayer* self) {
	EaseDocument* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_document;
#line 26 "ease-player.vala"
	return result;
#line 748 "ease-player.c"
}


void ease_player_set_document (EasePlayer* self, EaseDocument* value) {
	EaseDocument* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_document = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_document), _tmp0_);
	g_object_notify ((GObject *) self, "document");
}


gint ease_player_get_slide_index (EasePlayer* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_slide_index;
#line 27 "ease-player.vala"
	return result;
#line 766 "ease-player.c"
}


void ease_player_set_slide_index (EasePlayer* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_slide_index = value;
	g_object_notify ((GObject *) self, "slide-index");
}


ClutterStage* ease_player_get_stage (EasePlayer* self) {
	ClutterStage* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_stage;
#line 28 "ease-player.vala"
	return result;
#line 783 "ease-player.c"
}


void ease_player_set_stage (EasePlayer* self, ClutterStage* value) {
	ClutterStage* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_stage = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_stage), _tmp0_);
	g_object_notify ((GObject *) self, "stage");
}


static gboolean ease_player_get_can_animate (EasePlayer* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_animate;
#line 29 "ease-player.vala"
	return result;
#line 801 "ease-player.c"
}


static void ease_player_set_can_animate (EasePlayer* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_can_animate = value;
}


static void ease_player_class_init (EasePlayerClass * klass) {
	ease_player_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (EasePlayerPrivate));
	G_OBJECT_CLASS (klass)->get_property = ease_player_get_property;
	G_OBJECT_CLASS (klass)->set_property = ease_player_set_property;
	G_OBJECT_CLASS (klass)->finalize = ease_player_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_PLAYER_DOCUMENT, g_param_spec_object ("document", "document", "document", EASE_TYPE_DOCUMENT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_PLAYER_SLIDE_INDEX, g_param_spec_int ("slide-index", "slide-index", "slide-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), EASE_PLAYER_STAGE, g_param_spec_object ("stage", "stage", "stage", CLUTTER_TYPE_STAGE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void ease_player_instance_init (EasePlayer * self) {
	self->priv = EASE_PLAYER_GET_PRIVATE (self);
	self->priv->dragging = FALSE;
	self->priv->scale = (float) 1;
}


static void ease_player_finalize (GObject* obj) {
	EasePlayer * self;
	self = EASE_PLAYER (obj);
	_g_object_unref0 (self->priv->_document);
	_g_object_unref0 (self->priv->_stage);
	_g_object_unref0 (self->priv->current_slide);
	_g_object_unref0 (self->priv->old_slide);
	_g_object_unref0 (self->priv->container);
	_g_object_unref0 (self->priv->advance_alarm);
	_g_object_unref0 (self->priv->shader);
	_g_object_unref0 (self->priv->shader_top);
	_g_object_unref0 (self->priv->shader_bottom);
	_g_object_unref0 (self->priv->shader_left);
	_g_object_unref0 (self->priv->shader_right);
	G_OBJECT_CLASS (ease_player_parent_class)->finalize (obj);
}


GType ease_player_get_type (void) {
	static volatile gsize ease_player_type_id__volatile = 0;
	if (g_once_init_enter (&ease_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EasePlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EasePlayer), 0, (GInstanceInitFunc) ease_player_instance_init, NULL };
		GType ease_player_type_id;
		ease_player_type_id = g_type_register_static (G_TYPE_OBJECT, "EasePlayer", &g_define_type_info, 0);
		g_once_init_leave (&ease_player_type_id__volatile, ease_player_type_id);
	}
	return ease_player_type_id__volatile;
}


static void ease_player_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	EasePlayer * self;
	self = EASE_PLAYER (object);
	switch (property_id) {
		case EASE_PLAYER_DOCUMENT:
		g_value_set_object (value, ease_player_get_document (self));
		break;
		case EASE_PLAYER_SLIDE_INDEX:
		g_value_set_int (value, ease_player_get_slide_index (self));
		break;
		case EASE_PLAYER_STAGE:
		g_value_set_object (value, ease_player_get_stage (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void ease_player_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	EasePlayer * self;
	self = EASE_PLAYER (object);
	switch (property_id) {
		case EASE_PLAYER_DOCUMENT:
		ease_player_set_document (self, g_value_get_object (value));
		break;
		case EASE_PLAYER_SLIDE_INDEX:
		ease_player_set_slide_index (self, g_value_get_int (value));
		break;
		case EASE_PLAYER_STAGE:
		ease_player_set_stage (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




