/* ease-transitions.c generated by valac, the Vala compiler
 * generated from ease-transitions.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <stdio.h>


#define EASE_TYPE_TRANSITIONS (ease_transitions_get_type ())
#define EASE_TRANSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EASE_TYPE_TRANSITIONS, EaseTransitions))
#define EASE_TRANSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EASE_TYPE_TRANSITIONS, EaseTransitionsClass))
#define EASE_IS_TRANSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EASE_TYPE_TRANSITIONS))
#define EASE_IS_TRANSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EASE_TYPE_TRANSITIONS))
#define EASE_TRANSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EASE_TYPE_TRANSITIONS, EaseTransitionsClass))

typedef struct _EaseTransitions EaseTransitions;
typedef struct _EaseTransitionsClass EaseTransitionsClass;
typedef struct _EaseTransitionsPrivate EaseTransitionsPrivate;

#define EASE_TYPE_TRANSITION (ease_transition_get_type ())

#define EASE_TYPE_TRANSITION_TYPE (ease_transition_type_get_type ())

#define EASE_TYPE_TRANSITION_VARIANT (ease_transition_variant_get_type ())
typedef struct _EaseTransition EaseTransition;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _EaseTransitions {
	GObject parent_instance;
	EaseTransitionsPrivate * priv;
};

struct _EaseTransitionsClass {
	GObjectClass parent_class;
};

typedef enum  {
	EASE_TRANSITION_TYPE_NONE,
	EASE_TRANSITION_TYPE_FADE,
	EASE_TRANSITION_TYPE_SLIDE,
	EASE_TRANSITION_TYPE_DROP,
	EASE_TRANSITION_TYPE_PIVOT,
	EASE_TRANSITION_TYPE_FLIP,
	EASE_TRANSITION_TYPE_REVOLVING_DOOR,
	EASE_TRANSITION_TYPE_REVEAL,
	EASE_TRANSITION_TYPE_FALL,
	EASE_TRANSITION_TYPE_SLATS,
	EASE_TRANSITION_TYPE_OPEN_DOOR,
	EASE_TRANSITION_TYPE_ZOOM,
	EASE_TRANSITION_TYPE_PANEL,
	EASE_TRANSITION_TYPE_SPIN_CONTENTS,
	EASE_TRANSITION_TYPE_SPRING_CONTENTS,
	EASE_TRANSITION_TYPE_SWING_CONTENTS,
	EASE_TRANSITION_TYPE_SLIDE_CONTENTS,
	EASE_TRANSITION_TYPE_ZOOM_CONTENTS
} EaseTransitionType;

typedef enum  {
	EASE_TRANSITION_VARIANT_UP,
	EASE_TRANSITION_VARIANT_DOWN,
	EASE_TRANSITION_VARIANT_LEFT,
	EASE_TRANSITION_VARIANT_RIGHT,
	EASE_TRANSITION_VARIANT_BOTTOM,
	EASE_TRANSITION_VARIANT_TOP,
	EASE_TRANSITION_VARIANT_CENTER,
	EASE_TRANSITION_VARIANT_TOP_LEFT,
	EASE_TRANSITION_VARIANT_TOP_RIGHT,
	EASE_TRANSITION_VARIANT_BOTTOM_LEFT,
	EASE_TRANSITION_VARIANT_BOTTOM_RIGHT,
	EASE_TRANSITION_VARIANT_TOP_TO_BOTTOM,
	EASE_TRANSITION_VARIANT_BOTTOM_TO_TOP,
	EASE_TRANSITION_VARIANT_LEFT_TO_RIGHT,
	EASE_TRANSITION_VARIANT_RIGHT_TO_LEFT,
	EASE_TRANSITION_VARIANT_IN,
	EASE_TRANSITION_VARIANT_OUT
} EaseTransitionVariant;

struct _EaseTransition {
	EaseTransitionType type;
	EaseTransitionVariant* variants;
	gint variants_length1;
};


static EaseTransition* ease_transitions_transitions;
static gint ease_transitions_transitions_length1;
static EaseTransition* ease_transitions_transitions = NULL;
static gint ease_transitions_transitions_length1 = 0;
static gint _ease_transitions_transitions_size_ = 0;
static gpointer ease_transitions_parent_class = NULL;

GType ease_transitions_get_type (void) G_GNUC_CONST;
enum  {
	EASE_TRANSITIONS_DUMMY_PROPERTY
};
GType ease_transition_get_type (void) G_GNUC_CONST;
GType ease_transition_type_get_type (void) G_GNUC_CONST;
GType ease_transition_variant_get_type (void) G_GNUC_CONST;
EaseTransition* ease_transition_dup (const EaseTransition* self);
void ease_transition_free (EaseTransition* self);
void ease_transition_copy (const EaseTransition* self, EaseTransition* dest);
void ease_transition_destroy (EaseTransition* self);
static void _vala_EaseTransition_array_free (EaseTransition* array, gint array_length);
void ease_transitions_init (void);
char* ease_transitions_get_name (EaseTransitionType type);
char* ease_transitions_get_variant_name (EaseTransitionVariant variant);
EaseTransition* ease_transitions_get_transition (EaseTransitionType type);
static gint* _int_dup (gint* self);
gint* ease_transitions_get_index (EaseTransitionType type);
EaseTransitionType ease_transitions_transition_for_index (gint index);
static EaseTransitionVariant* _vala_array_dup1 (EaseTransitionVariant* self, int length);
EaseTransitionVariant* ease_transitions_variants_for_index (gint index, int* result_length1);
EaseTransitionVariant* ease_transitions_variants_for_transition (EaseTransitionType t, int* result_length1);
char** ease_transitions_names (int* result_length1);
char* ease_transitions_name (gint index);
void ease_transitions_test (void);
EaseTransitions* ease_transitions_new (void);
EaseTransitions* ease_transitions_construct (GType object_type);
gint ease_transitions_get_size (void);
static void ease_transitions_finalize (GObject* obj);
static void ease_transitions_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static EaseTransitionVariant* _vala_array_dup2 (EaseTransitionVariant* self, int length);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



static void _vala_EaseTransition_array_free (EaseTransition* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			ease_transition_destroy (&array[i]);
		}
	}
	g_free (array);
}


#line 30 "ease-transitions.vala"
void ease_transitions_init (void) {
#line 162 "ease-transitions.c"
	EaseTransition* _tmp37_;
	EaseTransition* _tmp36_ = NULL;
	EaseTransitionVariant* _tmp34_ = NULL;
	EaseTransitionVariant* _tmp32_ = NULL;
	EaseTransitionVariant* _tmp30_ = NULL;
	EaseTransitionVariant* _tmp28_ = NULL;
	EaseTransitionVariant* _tmp26_ = NULL;
	EaseTransitionVariant* _tmp24_ = NULL;
	EaseTransitionVariant* _tmp22_ = NULL;
	EaseTransitionVariant* _tmp20_ = NULL;
	EaseTransitionVariant* _tmp18_ = NULL;
	EaseTransitionVariant* _tmp16_ = NULL;
	EaseTransitionVariant* _tmp14_ = NULL;
	EaseTransitionVariant* _tmp12_ = NULL;
	EaseTransitionVariant* _tmp10_ = NULL;
	EaseTransitionVariant* _tmp8_ = NULL;
	EaseTransitionVariant* _tmp6_ = NULL;
	EaseTransitionVariant* _tmp4_ = NULL;
	EaseTransitionVariant* _tmp2_ = NULL;
	EaseTransitionVariant* _tmp0_ = NULL;
	EaseTransition _tmp1_ = {0};
	EaseTransition _tmp3_ = {0};
	EaseTransition _tmp5_ = {0};
	EaseTransition _tmp7_ = {0};
	EaseTransition _tmp9_ = {0};
	EaseTransition _tmp11_ = {0};
	EaseTransition _tmp13_ = {0};
	EaseTransition _tmp15_ = {0};
	EaseTransition _tmp17_ = {0};
	EaseTransition _tmp19_ = {0};
	EaseTransition _tmp21_ = {0};
	EaseTransition _tmp23_ = {0};
	EaseTransition _tmp25_ = {0};
	EaseTransition _tmp27_ = {0};
	EaseTransition _tmp29_ = {0};
	EaseTransition _tmp31_ = {0};
	EaseTransition _tmp33_ = {0};
	EaseTransition _tmp35_ = {0};
#line 32 "ease-transitions.vala"
	ease_transitions_transitions = (_tmp37_ = (_tmp36_ = g_new0 (EaseTransition, 18), _tmp36_[0] = (memset (&_tmp1_, 0, sizeof (EaseTransition)), _tmp1_.type = EASE_TRANSITION_TYPE_NONE, _tmp1_.variants = (_tmp0_ = g_new0 (EaseTransitionVariant, 0), _tmp0_), _tmp1_.variants_length1 = 0, _tmp1_), _tmp36_[1] = (memset (&_tmp3_, 0, sizeof (EaseTransition)), _tmp3_.type = EASE_TRANSITION_TYPE_FADE, _tmp3_.variants = (_tmp2_ = g_new0 (EaseTransitionVariant, 0), _tmp2_), _tmp3_.variants_length1 = 0, _tmp3_), _tmp36_[2] = (memset (&_tmp5_, 0, sizeof (EaseTransition)), _tmp5_.type = EASE_TRANSITION_TYPE_SLIDE, _tmp5_.variants = (_tmp4_ = g_new0 (EaseTransitionVariant, 4), _tmp4_[0] = EASE_TRANSITION_VARIANT_UP, _tmp4_[1] = EASE_TRANSITION_VARIANT_DOWN, _tmp4_[2] = EASE_TRANSITION_VARIANT_LEFT, _tmp4_[3] = EASE_TRANSITION_VARIANT_RIGHT, _tmp4_), _tmp5_.variants_length1 = 4, _tmp5_), _tmp36_[3] = (memset (&_tmp7_, 0, sizeof (EaseTransition)), _tmp7_.type = EASE_TRANSITION_TYPE_DROP, _tmp7_.variants = (_tmp6_ = g_new0 (EaseTransitionVariant, 0), _tmp6_), _tmp7_.variants_length1 = 0, _tmp7_), _tmp36_[4] = (memset (&_tmp9_, 0, sizeof (EaseTransition)), _tmp9_.type = EASE_TRANSITION_TYPE_PIVOT, _tmp9_.variants = (_tmp8_ = g_new0 (EaseTransitionVariant, 4), _tmp8_[0] = EASE_TRANSITION_VARIANT_TOP_LEFT, _tmp8_[1] = EASE_TRANSITION_VARIANT_TOP_RIGHT, _tmp8_[2] = EASE_TRANSITION_VARIANT_BOTTOM_LEFT, _tmp8_[3] = EASE_TRANSITION_VARIANT_BOTTOM_RIGHT, _tmp8_), _tmp9_.variants_length1 = 4, _tmp9_), _tmp36_[5] = (memset (&_tmp11_, 0, sizeof (EaseTransition)), _tmp11_.type = EASE_TRANSITION_TYPE_FLIP, _tmp11_.variants = (_tmp10_ = g_new0 (EaseTransitionVariant, 4), _tmp10_[0] = EASE_TRANSITION_VARIANT_TOP_TO_BOTTOM, _tmp10_[1] = EASE_TRANSITION_VARIANT_BOTTOM_TO_TOP, _tmp10_[2] = EASE_TRANSITION_VARIANT_LEFT_TO_RIGHT, _tmp10_[3] = EASE_TRANSITION_VARIANT_RIGHT_TO_LEFT, _tmp10_), _tmp11_.variants_length1 = 4, _tmp11_), _tmp36_[6] = (memset (&_tmp13_, 0, sizeof (EaseTransition)), _tmp13_.type = EASE_TRANSITION_TYPE_REVOLVING_DOOR, _tmp13_.variants = (_tmp12_ = g_new0 (EaseTransitionVariant, 4), _tmp12_[0] = EASE_TRANSITION_VARIANT_UP, _tmp12_[1] = EASE_TRANSITION_VARIANT_DOWN, _tmp12_[2] = EASE_TRANSITION_VARIANT_LEFT, _tmp12_[3] = EASE_TRANSITION_VARIANT_RIGHT, _tmp12_), _tmp13_.variants_length1 = 4, _tmp13_), _tmp36_[7] = (memset (&_tmp15_, 0, sizeof (EaseTransition)), _tmp15_.type = EASE_TRANSITION_TYPE_REVEAL, _tmp15_.variants = (_tmp14_ = g_new0 (EaseTransitionVariant, 4), _tmp14_[0] = EASE_TRANSITION_VARIANT_UP, _tmp14_[1] = EASE_TRANSITION_VARIANT_DOWN, _tmp14_[2] = EASE_TRANSITION_VARIANT_LEFT, _tmp14_[3] = EASE_TRANSITION_VARIANT_RIGHT, _tmp14_), _tmp15_.variants_length1 = 4, _tmp15_), _tmp36_[8] = (memset (&_tmp17_, 0, sizeof (EaseTransition)), _tmp17_.type = EASE_TRANSITION_TYPE_FALL, _tmp17_.variants = (_tmp16_ = g_new0 (EaseTransitionVariant, 0), _tmp16_), _tmp17_.variants_length1 = 0, _tmp17_), _tmp36_[9] = (memset (&_tmp19_, 0, sizeof (EaseTransition)), _tmp19_.type = EASE_TRANSITION_TYPE_SLATS, _tmp19_.variants = (_tmp18_ = g_new0 (EaseTransitionVariant, 0), _tmp18_), _tmp19_.variants_length1 = 0, _tmp19_), _tmp36_[10] = (memset (&_tmp21_, 0, sizeof (EaseTransition)), _tmp21_.type = EASE_TRANSITION_TYPE_OPEN_DOOR, _tmp21_.variants = (_tmp20_ = g_new0 (EaseTransitionVariant, 0), _tmp20_), _tmp21_.variants_length1 = 0, _tmp21_), _tmp36_[11] = (memset (&_tmp23_, 0, sizeof (EaseTransition)), _tmp23_.type = EASE_TRANSITION_TYPE_ZOOM, _tmp23_.variants = (_tmp22_ = g_new0 (EaseTransitionVariant, 5), _tmp22_[0] = EASE_TRANSITION_VARIANT_CENTER, _tmp22_[1] = EASE_TRANSITION_VARIANT_TOP_LEFT, _tmp22_[2] = EASE_TRANSITION_VARIANT_TOP_RIGHT, _tmp22_[3] = EASE_TRANSITION_VARIANT_BOTTOM_LEFT, _tmp22_[4] = EASE_TRANSITION_VARIANT_BOTTOM_RIGHT, _tmp22_), _tmp23_.variants_length1 = 5, _tmp23_), _tmp36_[12] = (memset (&_tmp25_, 0, sizeof (EaseTransition)), _tmp25_.type = EASE_TRANSITION_TYPE_PANEL, _tmp25_.variants = (_tmp24_ = g_new0 (EaseTransitionVariant, 4), _tmp24_[0] = EASE_TRANSITION_VARIANT_UP, _tmp24_[1] = EASE_TRANSITION_VARIANT_DOWN, _tmp24_[2] = EASE_TRANSITION_VARIANT_LEFT, _tmp24_[3] = EASE_TRANSITION_VARIANT_RIGHT, _tmp24_), _tmp25_.variants_length1 = 4, _tmp25_), _tmp36_[13] = (memset (&_tmp27_, 0, sizeof (EaseTransition)), _tmp27_.type = EASE_TRANSITION_TYPE_SPIN_CONTENTS, _tmp27_.variants = (_tmp26_ = g_new0 (EaseTransitionVariant, 2), _tmp26_[0] = EASE_TRANSITION_VARIANT_LEFT, _tmp26_[1] = EASE_TRANSITION_VARIANT_RIGHT, _tmp26_), _tmp27_.variants_length1 = 2, _tmp27_), _tmp36_[14] = (memset (&_tmp29_, 0, sizeof (EaseTransition)), _tmp29_.type = EASE_TRANSITION_TYPE_SWING_CONTENTS, _tmp29_.variants = (_tmp28_ = g_new0 (EaseTransitionVariant, 0), _tmp28_), _tmp29_.variants_length1 = 0, _tmp29_), _tmp36_[15] = (memset (&_tmp31_, 0, sizeof (EaseTransition)), _tmp31_.type = EASE_TRANSITION_TYPE_SLIDE_CONTENTS, _tmp31_.variants = (_tmp30_ = g_new0 (EaseTransitionVariant, 4), _tmp30_[0] = EASE_TRANSITION_VARIANT_UP, _tmp30_[1] = EASE_TRANSITION_VARIANT_DOWN, _tmp30_[2] = EASE_TRANSITION_VARIANT_LEFT, _tmp30_[3] = EASE_TRANSITION_VARIANT_RIGHT, _tmp30_), _tmp31_.variants_length1 = 4, _tmp31_), _tmp36_[16] = (memset (&_tmp33_, 0, sizeof (EaseTransition)), _tmp33_.type = EASE_TRANSITION_TYPE_SPRING_CONTENTS, _tmp33_.variants = (_tmp32_ = g_new0 (EaseTransitionVariant, 2), _tmp32_[0] = EASE_TRANSITION_VARIANT_UP, _tmp32_[1] = EASE_TRANSITION_VARIANT_DOWN, _tmp32_), _tmp33_.variants_length1 = 2, _tmp33_), _tmp36_[17] = (memset (&_tmp35_, 0, sizeof (EaseTransition)), _tmp35_.type = EASE_TRANSITION_TYPE_ZOOM_CONTENTS, _tmp35_.variants = (_tmp34_ = g_new0 (EaseTransitionVariant, 2), _tmp34_[0] = EASE_TRANSITION_VARIANT_IN, _tmp34_[1] = EASE_TRANSITION_VARIANT_OUT, _tmp34_), _tmp35_.variants_length1 = 2, _tmp35_), _tmp36_), ease_transitions_transitions = (_vala_EaseTransition_array_free (ease_transitions_transitions, ease_transitions_transitions_length1), NULL), ease_transitions_transitions_length1 = 18, _ease_transitions_transitions_size_ = ease_transitions_transitions_length1, _tmp37_);
#line 203 "ease-transitions.c"
}


#line 99 "ease-transitions.vala"
char* ease_transitions_get_name (EaseTransitionType type) {
#line 209 "ease-transitions.c"
	char* result = NULL;
#line 101 "ease-transitions.vala"
	switch (type) {
#line 213 "ease-transitions.c"
		case EASE_TRANSITION_TYPE_NONE:
		{
			result = g_strdup (_ ("None"));
#line 104 "ease-transitions.vala"
			return result;
#line 219 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_FADE:
		{
			result = g_strdup (_ ("Fade"));
#line 106 "ease-transitions.vala"
			return result;
#line 226 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_SLIDE:
		{
			result = g_strdup (_ ("Slide"));
#line 108 "ease-transitions.vala"
			return result;
#line 233 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_DROP:
		{
			result = g_strdup (_ ("Drop"));
#line 110 "ease-transitions.vala"
			return result;
#line 240 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_PIVOT:
		{
			result = g_strdup (_ ("Pivot"));
#line 112 "ease-transitions.vala"
			return result;
#line 247 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_FLIP:
		{
			result = g_strdup (_ ("Flip"));
#line 114 "ease-transitions.vala"
			return result;
#line 254 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_REVOLVING_DOOR:
		{
			result = g_strdup (_ ("Revolving Door"));
#line 116 "ease-transitions.vala"
			return result;
#line 261 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_REVEAL:
		{
			result = g_strdup (_ ("Reveal"));
#line 118 "ease-transitions.vala"
			return result;
#line 268 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_FALL:
		{
			result = g_strdup (_ ("Fall"));
#line 120 "ease-transitions.vala"
			return result;
#line 275 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_SLATS:
		{
			result = g_strdup (_ ("Slats"));
#line 122 "ease-transitions.vala"
			return result;
#line 282 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_OPEN_DOOR:
		{
			result = g_strdup (_ ("Open Door"));
#line 124 "ease-transitions.vala"
			return result;
#line 289 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_ZOOM:
		{
			result = g_strdup (_ ("Zoom"));
#line 126 "ease-transitions.vala"
			return result;
#line 296 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_PANEL:
		{
			result = g_strdup (_ ("Panel"));
#line 128 "ease-transitions.vala"
			return result;
#line 303 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_SPIN_CONTENTS:
		{
			result = g_strdup (_ ("Spin Contents"));
#line 130 "ease-transitions.vala"
			return result;
#line 310 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_SPRING_CONTENTS:
		{
			result = g_strdup (_ ("Spring Contents"));
#line 132 "ease-transitions.vala"
			return result;
#line 317 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_SWING_CONTENTS:
		{
			result = g_strdup (_ ("Swing Contents"));
#line 134 "ease-transitions.vala"
			return result;
#line 324 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_SLIDE_CONTENTS:
		{
			result = g_strdup (_ ("Slide Contents"));
#line 136 "ease-transitions.vala"
			return result;
#line 331 "ease-transitions.c"
		}
		case EASE_TRANSITION_TYPE_ZOOM_CONTENTS:
		{
			result = g_strdup (_ ("Zoom Contents"));
#line 138 "ease-transitions.vala"
			return result;
#line 338 "ease-transitions.c"
		}
		default:
		{
			result = g_strdup (_ ("Undefined"));
#line 140 "ease-transitions.vala"
			return result;
#line 345 "ease-transitions.c"
		}
	}
}


#line 149 "ease-transitions.vala"
char* ease_transitions_get_variant_name (EaseTransitionVariant variant) {
#line 353 "ease-transitions.c"
	char* result = NULL;
#line 151 "ease-transitions.vala"
	switch (variant) {
#line 357 "ease-transitions.c"
		case EASE_TRANSITION_VARIANT_UP:
		{
			result = g_strdup (_ ("Up"));
#line 154 "ease-transitions.vala"
			return result;
#line 363 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_DOWN:
		{
			result = g_strdup (_ ("Down"));
#line 156 "ease-transitions.vala"
			return result;
#line 370 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_LEFT:
		{
			result = g_strdup (_ ("Left"));
#line 158 "ease-transitions.vala"
			return result;
#line 377 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_RIGHT:
		{
			result = g_strdup (_ ("Right"));
#line 160 "ease-transitions.vala"
			return result;
#line 384 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_BOTTOM:
		{
			result = g_strdup (_ ("Bottom"));
#line 162 "ease-transitions.vala"
			return result;
#line 391 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_TOP:
		{
			result = g_strdup (_ ("Top"));
#line 164 "ease-transitions.vala"
			return result;
#line 398 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_CENTER:
		{
			result = g_strdup (_ ("Center"));
#line 166 "ease-transitions.vala"
			return result;
#line 405 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_TOP_LEFT:
		{
			result = g_strdup (_ ("Top Left"));
#line 168 "ease-transitions.vala"
			return result;
#line 412 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_TOP_RIGHT:
		{
			result = g_strdup (_ ("Top Right"));
#line 170 "ease-transitions.vala"
			return result;
#line 419 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_BOTTOM_LEFT:
		{
			result = g_strdup (_ ("Bottom Left"));
#line 172 "ease-transitions.vala"
			return result;
#line 426 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_BOTTOM_RIGHT:
		{
			result = g_strdup (_ ("Bottom Right"));
#line 174 "ease-transitions.vala"
			return result;
#line 433 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_TOP_TO_BOTTOM:
		{
			result = g_strdup (_ ("Top to Bottom"));
#line 176 "ease-transitions.vala"
			return result;
#line 440 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_BOTTOM_TO_TOP:
		{
			result = g_strdup (_ ("Bottom to Top"));
#line 178 "ease-transitions.vala"
			return result;
#line 447 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_LEFT_TO_RIGHT:
		{
			result = g_strdup (_ ("Left to Right"));
#line 180 "ease-transitions.vala"
			return result;
#line 454 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_RIGHT_TO_LEFT:
		{
			result = g_strdup (_ ("Right to Left"));
#line 182 "ease-transitions.vala"
			return result;
#line 461 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_IN:
		{
			result = g_strdup (_ ("In"));
#line 184 "ease-transitions.vala"
			return result;
#line 468 "ease-transitions.c"
		}
		case EASE_TRANSITION_VARIANT_OUT:
		{
			result = g_strdup (_ ("Out"));
#line 186 "ease-transitions.vala"
			return result;
#line 475 "ease-transitions.c"
		}
		default:
		{
			result = g_strdup (_ ("Undefined"));
#line 188 "ease-transitions.vala"
			return result;
#line 482 "ease-transitions.c"
		}
	}
}


static gpointer _ease_transition_dup0 (gpointer self) {
	return self ? ease_transition_dup (self) : NULL;
}


#line 197 "ease-transitions.vala"
EaseTransition* ease_transitions_get_transition (EaseTransitionType type) {
#line 495 "ease-transitions.c"
	EaseTransition* result = NULL;
	{
		gint i;
#line 199 "ease-transitions.vala"
		i = 0;
#line 501 "ease-transitions.c"
		{
			gboolean _tmp0_;
#line 199 "ease-transitions.vala"
			_tmp0_ = TRUE;
#line 199 "ease-transitions.vala"
			while (TRUE) {
#line 199 "ease-transitions.vala"
				if (!_tmp0_) {
#line 199 "ease-transitions.vala"
					i++;
#line 512 "ease-transitions.c"
				}
#line 199 "ease-transitions.vala"
				_tmp0_ = FALSE;
#line 199 "ease-transitions.vala"
				if (!(i < ease_transitions_transitions_length1)) {
#line 199 "ease-transitions.vala"
					break;
#line 520 "ease-transitions.c"
				}
#line 201 "ease-transitions.vala"
				if (ease_transitions_transitions[i].type == type) {
#line 524 "ease-transitions.c"
					EaseTransition _tmp1_;
					result = _ease_transition_dup0 ((_tmp1_ = ease_transitions_transitions[i], &_tmp1_));
#line 203 "ease-transitions.vala"
					return result;
#line 529 "ease-transitions.c"
				}
			}
		}
	}
	result = NULL;
#line 207 "ease-transitions.vala"
	return result;
#line 537 "ease-transitions.c"
}


static gint* _int_dup (gint* self) {
	gint* dup;
	dup = g_new0 (gint, 1);
	memcpy (dup, self, sizeof (gint));
	return dup;
}


static gpointer __int_dup0 (gpointer self) {
	return self ? _int_dup (self) : NULL;
}


#line 215 "ease-transitions.vala"
gint* ease_transitions_get_index (EaseTransitionType type) {
#line 556 "ease-transitions.c"
	gint* result = NULL;
	{
		gint i;
#line 217 "ease-transitions.vala"
		i = 0;
#line 562 "ease-transitions.c"
		{
			gboolean _tmp0_;
#line 217 "ease-transitions.vala"
			_tmp0_ = TRUE;
#line 217 "ease-transitions.vala"
			while (TRUE) {
#line 217 "ease-transitions.vala"
				if (!_tmp0_) {
#line 217 "ease-transitions.vala"
					i++;
#line 573 "ease-transitions.c"
				}
#line 217 "ease-transitions.vala"
				_tmp0_ = FALSE;
#line 217 "ease-transitions.vala"
				if (!(i < ease_transitions_transitions_length1)) {
#line 217 "ease-transitions.vala"
					break;
#line 581 "ease-transitions.c"
				}
#line 219 "ease-transitions.vala"
				if (ease_transitions_transitions[i].type == type) {
#line 585 "ease-transitions.c"
					result = __int_dup0 (&i);
#line 221 "ease-transitions.vala"
					return result;
#line 589 "ease-transitions.c"
				}
			}
		}
	}
	result = NULL;
#line 225 "ease-transitions.vala"
	return result;
#line 597 "ease-transitions.c"
}


#line 233 "ease-transitions.vala"
EaseTransitionType ease_transitions_transition_for_index (gint index) {
#line 603 "ease-transitions.c"
	EaseTransitionType result = 0;
	result = ease_transitions_transitions[index].type;
#line 235 "ease-transitions.vala"
	return result;
#line 608 "ease-transitions.c"
}


static EaseTransitionVariant* _vala_array_dup1 (EaseTransitionVariant* self, int length) {
	return g_memdup (self, length * sizeof (EaseTransitionVariant));
}


#line 243 "ease-transitions.vala"
EaseTransitionVariant* ease_transitions_variants_for_index (gint index, int* result_length1) {
#line 619 "ease-transitions.c"
	EaseTransitionVariant* result = NULL;
	EaseTransitionVariant* _tmp0_;
	EaseTransitionVariant* _tmp1_;
	result = (_tmp1_ = (_tmp0_ = ease_transitions_transitions[index].variants, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup1 (_tmp0_, ease_transitions_transitions[index].variants_length1)), *result_length1 = ease_transitions_transitions[index].variants_length1, _tmp1_);
#line 245 "ease-transitions.vala"
	return result;
#line 626 "ease-transitions.c"
}


#line 253 "ease-transitions.vala"
EaseTransitionVariant* ease_transitions_variants_for_transition (EaseTransitionType t, int* result_length1) {
#line 632 "ease-transitions.c"
	EaseTransitionVariant* result = NULL;
	gint _tmp1_;
	gint* _tmp0_;
	EaseTransitionVariant* _tmp2_;
	EaseTransitionVariant* _tmp3_;
	result = (_tmp3_ = (_tmp2_ = ease_transitions_variants_for_index (*(_tmp0_ = ease_transitions_get_index (t)), &_tmp1_), _g_free0 (_tmp0_), _tmp2_), *result_length1 = _tmp1_, _tmp3_);
#line 255 "ease-transitions.vala"
	return result;
#line 641 "ease-transitions.c"
}


#line 261 "ease-transitions.vala"
char** ease_transitions_names (int* result_length1) {
#line 647 "ease-transitions.c"
	char** result = NULL;
	char** _tmp0_;
	gint _names_size_;
	gint names_length1;
	char** names;
	char** _tmp3_;
	names = (_tmp0_ = g_new0 (char*, ease_transitions_transitions_length1 + 1), names_length1 = ease_transitions_transitions_length1, _names_size_ = names_length1, _tmp0_);
	{
		gint i;
#line 265 "ease-transitions.vala"
		i = 0;
#line 659 "ease-transitions.c"
		{
			gboolean _tmp1_;
#line 265 "ease-transitions.vala"
			_tmp1_ = TRUE;
#line 265 "ease-transitions.vala"
			while (TRUE) {
#line 666 "ease-transitions.c"
				char* _tmp2_;
#line 265 "ease-transitions.vala"
				if (!_tmp1_) {
#line 265 "ease-transitions.vala"
					i++;
#line 672 "ease-transitions.c"
				}
#line 265 "ease-transitions.vala"
				_tmp1_ = FALSE;
#line 265 "ease-transitions.vala"
				if (!(i < ease_transitions_transitions_length1)) {
#line 265 "ease-transitions.vala"
					break;
#line 680 "ease-transitions.c"
				}
#line 267 "ease-transitions.vala"
				names[i] = (_tmp2_ = ease_transitions_get_name (ease_transitions_transitions[i].type), _g_free0 (names[i]), _tmp2_);
#line 684 "ease-transitions.c"
			}
		}
	}
	result = (_tmp3_ = names, *result_length1 = names_length1, _tmp3_);
#line 270 "ease-transitions.vala"
	return result;
#line 691 "ease-transitions.c"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
}


#line 278 "ease-transitions.vala"
char* ease_transitions_name (gint index) {
#line 698 "ease-transitions.c"
	char* result = NULL;
	result = ease_transitions_get_name (ease_transitions_transitions[index].type);
#line 280 "ease-transitions.vala"
	return result;
#line 703 "ease-transitions.c"
}


#line 286 "ease-transitions.vala"
void ease_transitions_test (void) {
#line 288 "ease-transitions.vala"
	fprintf (stdout, "%i Transitions:\n", (gint) ease_transitions_transitions_length1);
#line 711 "ease-transitions.c"
	{
		gint i;
#line 290 "ease-transitions.vala"
		i = 0;
#line 716 "ease-transitions.c"
		{
			gboolean _tmp0_;
#line 290 "ease-transitions.vala"
			_tmp0_ = TRUE;
#line 290 "ease-transitions.vala"
			while (TRUE) {
#line 723 "ease-transitions.c"
				char* _tmp1_;
#line 290 "ease-transitions.vala"
				if (!_tmp0_) {
#line 290 "ease-transitions.vala"
					i++;
#line 729 "ease-transitions.c"
				}
#line 290 "ease-transitions.vala"
				_tmp0_ = FALSE;
#line 290 "ease-transitions.vala"
				if (!(i < ease_transitions_transitions_length1)) {
#line 290 "ease-transitions.vala"
					break;
#line 737 "ease-transitions.c"
				}
#line 292 "ease-transitions.vala"
				fprintf (stdout, "\t%s has %i variants:\n", _tmp1_ = ease_transitions_get_name (ease_transitions_transitions[i].type), ease_transitions_transitions[i].variants_length1);
#line 741 "ease-transitions.c"
				_g_free0 (_tmp1_);
				{
					gint j;
#line 296 "ease-transitions.vala"
					j = 0;
#line 747 "ease-transitions.c"
					{
						gboolean _tmp2_;
#line 296 "ease-transitions.vala"
						_tmp2_ = TRUE;
#line 296 "ease-transitions.vala"
						while (TRUE) {
#line 754 "ease-transitions.c"
							char* _tmp3_;
#line 296 "ease-transitions.vala"
							if (!_tmp2_) {
#line 296 "ease-transitions.vala"
								j++;
#line 760 "ease-transitions.c"
							}
#line 296 "ease-transitions.vala"
							_tmp2_ = FALSE;
#line 296 "ease-transitions.vala"
							if (!(j < ease_transitions_transitions[i].variants_length1)) {
#line 296 "ease-transitions.vala"
								break;
#line 768 "ease-transitions.c"
							}
#line 298 "ease-transitions.vala"
							fprintf (stdout, "\t\t%s\n", _tmp3_ = ease_transitions_get_variant_name (ease_transitions_transitions[i].variants[j]));
#line 772 "ease-transitions.c"
							_g_free0 (_tmp3_);
						}
					}
				}
			}
		}
	}
}


#line 24 "ease-transitions.vala"
EaseTransitions* ease_transitions_construct (GType object_type) {
#line 785 "ease-transitions.c"
	EaseTransitions * self;
#line 24 "ease-transitions.vala"
	self = (EaseTransitions*) g_object_new (object_type, NULL);
#line 789 "ease-transitions.c"
	return self;
}


#line 24 "ease-transitions.vala"
EaseTransitions* ease_transitions_new (void) {
#line 24 "ease-transitions.vala"
	return ease_transitions_construct (EASE_TYPE_TRANSITIONS);
#line 798 "ease-transitions.c"
}


gint ease_transitions_get_size (void) {
	gint result;
	result = ease_transitions_transitions_length1;
#line 28 "ease-transitions.vala"
	return result;
#line 807 "ease-transitions.c"
}


static void ease_transitions_class_init (EaseTransitionsClass * klass) {
	ease_transitions_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = ease_transitions_get_property;
	G_OBJECT_CLASS (klass)->finalize = ease_transitions_finalize;
}


static void ease_transitions_instance_init (EaseTransitions * self) {
}


static void ease_transitions_finalize (GObject* obj) {
	EaseTransitions * self;
	self = EASE_TRANSITIONS (obj);
	G_OBJECT_CLASS (ease_transitions_parent_class)->finalize (obj);
}


GType ease_transitions_get_type (void) {
	static volatile gsize ease_transitions_type_id__volatile = 0;
	if (g_once_init_enter (&ease_transitions_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EaseTransitionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ease_transitions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EaseTransitions), 0, (GInstanceInitFunc) ease_transitions_instance_init, NULL };
		GType ease_transitions_type_id;
		ease_transitions_type_id = g_type_register_static (G_TYPE_OBJECT, "EaseTransitions", &g_define_type_info, 0);
		g_once_init_leave (&ease_transitions_type_id__volatile, ease_transitions_type_id);
	}
	return ease_transitions_type_id__volatile;
}


static void ease_transitions_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	EaseTransitions * self;
	self = EASE_TRANSITIONS (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static EaseTransitionVariant* _vala_array_dup2 (EaseTransitionVariant* self, int length) {
	return g_memdup (self, length * sizeof (EaseTransitionVariant));
}


void ease_transition_copy (const EaseTransition* self, EaseTransition* dest) {
	EaseTransitionVariant* _tmp0_;
	dest->type = self->type;
	dest->variants = (_tmp0_ = self->variants, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup2 (_tmp0_, (*self).variants_length1));
	dest->variants_length1 = self->variants_length1;
}


void ease_transition_destroy (EaseTransition* self) {
	self->variants = (g_free (self->variants), NULL);
}


EaseTransition* ease_transition_dup (const EaseTransition* self) {
	EaseTransition* dup;
	dup = g_new0 (EaseTransition, 1);
	ease_transition_copy (self, dup);
	return dup;
}


void ease_transition_free (EaseTransition* self) {
	ease_transition_destroy (self);
	g_free (self);
}


GType ease_transition_get_type (void) {
	static volatile gsize ease_transition_type_id__volatile = 0;
	if (g_once_init_enter (&ease_transition_type_id__volatile)) {
		GType ease_transition_type_id;
		ease_transition_type_id = g_boxed_type_register_static ("EaseTransition", (GBoxedCopyFunc) ease_transition_dup, (GBoxedFreeFunc) ease_transition_free);
		g_once_init_leave (&ease_transition_type_id__volatile, ease_transition_type_id);
	}
	return ease_transition_type_id__volatile;
}


GType ease_transition_type_get_type (void) {
	static volatile gsize ease_transition_type_type_id__volatile = 0;
	if (g_once_init_enter (&ease_transition_type_type_id__volatile)) {
		static const GEnumValue values[] = {{EASE_TRANSITION_TYPE_NONE, "EASE_TRANSITION_TYPE_NONE", "none"}, {EASE_TRANSITION_TYPE_FADE, "EASE_TRANSITION_TYPE_FADE", "fade"}, {EASE_TRANSITION_TYPE_SLIDE, "EASE_TRANSITION_TYPE_SLIDE", "slide"}, {EASE_TRANSITION_TYPE_DROP, "EASE_TRANSITION_TYPE_DROP", "drop"}, {EASE_TRANSITION_TYPE_PIVOT, "EASE_TRANSITION_TYPE_PIVOT", "pivot"}, {EASE_TRANSITION_TYPE_FLIP, "EASE_TRANSITION_TYPE_FLIP", "flip"}, {EASE_TRANSITION_TYPE_REVOLVING_DOOR, "EASE_TRANSITION_TYPE_REVOLVING_DOOR", "revolving-door"}, {EASE_TRANSITION_TYPE_REVEAL, "EASE_TRANSITION_TYPE_REVEAL", "reveal"}, {EASE_TRANSITION_TYPE_FALL, "EASE_TRANSITION_TYPE_FALL", "fall"}, {EASE_TRANSITION_TYPE_SLATS, "EASE_TRANSITION_TYPE_SLATS", "slats"}, {EASE_TRANSITION_TYPE_OPEN_DOOR, "EASE_TRANSITION_TYPE_OPEN_DOOR", "open-door"}, {EASE_TRANSITION_TYPE_ZOOM, "EASE_TRANSITION_TYPE_ZOOM", "zoom"}, {EASE_TRANSITION_TYPE_PANEL, "EASE_TRANSITION_TYPE_PANEL", "panel"}, {EASE_TRANSITION_TYPE_SPIN_CONTENTS, "EASE_TRANSITION_TYPE_SPIN_CONTENTS", "spin-contents"}, {EASE_TRANSITION_TYPE_SPRING_CONTENTS, "EASE_TRANSITION_TYPE_SPRING_CONTENTS", "spring-contents"}, {EASE_TRANSITION_TYPE_SWING_CONTENTS, "EASE_TRANSITION_TYPE_SWING_CONTENTS", "swing-contents"}, {EASE_TRANSITION_TYPE_SLIDE_CONTENTS, "EASE_TRANSITION_TYPE_SLIDE_CONTENTS", "slide-contents"}, {EASE_TRANSITION_TYPE_ZOOM_CONTENTS, "EASE_TRANSITION_TYPE_ZOOM_CONTENTS", "zoom-contents"}, {0, NULL, NULL}};
		GType ease_transition_type_type_id;
		ease_transition_type_type_id = g_enum_register_static ("EaseTransitionType", values);
		g_once_init_leave (&ease_transition_type_type_id__volatile, ease_transition_type_type_id);
	}
	return ease_transition_type_type_id__volatile;
}


GType ease_transition_variant_get_type (void) {
	static volatile gsize ease_transition_variant_type_id__volatile = 0;
	if (g_once_init_enter (&ease_transition_variant_type_id__volatile)) {
		static const GEnumValue values[] = {{EASE_TRANSITION_VARIANT_UP, "EASE_TRANSITION_VARIANT_UP", "up"}, {EASE_TRANSITION_VARIANT_DOWN, "EASE_TRANSITION_VARIANT_DOWN", "down"}, {EASE_TRANSITION_VARIANT_LEFT, "EASE_TRANSITION_VARIANT_LEFT", "left"}, {EASE_TRANSITION_VARIANT_RIGHT, "EASE_TRANSITION_VARIANT_RIGHT", "right"}, {EASE_TRANSITION_VARIANT_BOTTOM, "EASE_TRANSITION_VARIANT_BOTTOM", "bottom"}, {EASE_TRANSITION_VARIANT_TOP, "EASE_TRANSITION_VARIANT_TOP", "top"}, {EASE_TRANSITION_VARIANT_CENTER, "EASE_TRANSITION_VARIANT_CENTER", "center"}, {EASE_TRANSITION_VARIANT_TOP_LEFT, "EASE_TRANSITION_VARIANT_TOP_LEFT", "top-left"}, {EASE_TRANSITION_VARIANT_TOP_RIGHT, "EASE_TRANSITION_VARIANT_TOP_RIGHT", "top-right"}, {EASE_TRANSITION_VARIANT_BOTTOM_LEFT, "EASE_TRANSITION_VARIANT_BOTTOM_LEFT", "bottom-left"}, {EASE_TRANSITION_VARIANT_BOTTOM_RIGHT, "EASE_TRANSITION_VARIANT_BOTTOM_RIGHT", "bottom-right"}, {EASE_TRANSITION_VARIANT_TOP_TO_BOTTOM, "EASE_TRANSITION_VARIANT_TOP_TO_BOTTOM", "top-to-bottom"}, {EASE_TRANSITION_VARIANT_BOTTOM_TO_TOP, "EASE_TRANSITION_VARIANT_BOTTOM_TO_TOP", "bottom-to-top"}, {EASE_TRANSITION_VARIANT_LEFT_TO_RIGHT, "EASE_TRANSITION_VARIANT_LEFT_TO_RIGHT", "left-to-right"}, {EASE_TRANSITION_VARIANT_RIGHT_TO_LEFT, "EASE_TRANSITION_VARIANT_RIGHT_TO_LEFT", "right-to-left"}, {EASE_TRANSITION_VARIANT_IN, "EASE_TRANSITION_VARIANT_IN", "in"}, {EASE_TRANSITION_VARIANT_OUT, "EASE_TRANSITION_VARIANT_OUT", "out"}, {0, NULL, NULL}};
		GType ease_transition_variant_type_id;
		ease_transition_variant_type_id = g_enum_register_static ("EaseTransitionVariant", values);
		g_once_init_leave (&ease_transition_variant_type_id__volatile, ease_transition_variant_type_id);
	}
	return ease_transition_variant_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




