/* ease-utilities.c generated by valac, the Vala compiler
 * generated from ease-utilities.vala, do not modify */

/*  Ease, a GTK presentation application
    Copyright (C) 2010 Nate Stedman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



#define EASE_LOCAL_DATA "data"
#define EASE_SYS_DATA "ease"
void ease_error_dialog (const char* title, const char* message);
char* ease_query_file (const char* dir, const char* path);
static char** _vala_array_dup3 (char** self, int length);
char* ease_data_path (const char* path);
double ease_dmax (double a, double b);
double ease_dmin (double a, double b);
gint ease_roundd (double num);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



#line 36 "ease-utilities.vala"
void ease_error_dialog (const char* title, const char* message) {
#line 53 "ease-utilities.c"
	GtkMessageDialog* dialog;
#line 36 "ease-utilities.vala"
	g_return_if_fail (title != NULL);
#line 36 "ease-utilities.vala"
	g_return_if_fail (message != NULL);
#line 38 "ease-utilities.vala"
	dialog = g_object_ref_sink ((GtkMessageDialog*) gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", message));
#line 42 "ease-utilities.vala"
	gtk_window_set_title ((GtkWindow*) dialog, title);
#line 43 "ease-utilities.vala"
	gtk_container_set_border_width ((GtkContainer*) dialog, (guint) 5);
#line 44 "ease-utilities.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 45 "ease-utilities.vala"
	gtk_object_destroy ((GtkObject*) dialog);
#line 69 "ease-utilities.c"
	_g_object_unref0 (dialog);
}


static char** _vala_array_dup3 (char** self, int length) {
	char** result;
	int i;
	char** _tmp1_;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


#line 54 "ease-utilities.vala"
char* ease_data_path (const char* path) {
#line 88 "ease-utilities.c"
	char* result = NULL;
	char* file;
	char* _tmp0_;
	char** _tmp3_;
	gint _data_dirs_size_;
	gint data_dirs_length1;
	char** _tmp2_;
	char** _tmp1_;
	char** data_dirs;
#line 54 "ease-utilities.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 100 "ease-utilities.c"
	file = NULL;
#line 57 "ease-utilities.vala"
	file = (_tmp0_ = ease_query_file (EASE_LOCAL_DATA, path), _g_free0 (file), _tmp0_);
#line 58 "ease-utilities.vala"
	if (file != NULL) {
#line 106 "ease-utilities.c"
		result = file;
#line 58 "ease-utilities.vala"
		return result;
#line 110 "ease-utilities.c"
	}
	data_dirs = (_tmp3_ = (_tmp2_ = _tmp1_ = g_get_system_data_dirs (), (_tmp2_ == NULL) ? ((gpointer) _tmp2_) : _vala_array_dup3 (_tmp2_, _vala_array_length (_tmp1_))), data_dirs_length1 = _vala_array_length (_tmp1_), _data_dirs_size_ = data_dirs_length1, _tmp3_);
	{
		char** dir_collection;
		int dir_collection_length1;
		int dir_it;
#line 61 "ease-utilities.vala"
		dir_collection = data_dirs;
#line 119 "ease-utilities.c"
		dir_collection_length1 = data_dirs_length1;
		for (dir_it = 0; dir_it < data_dirs_length1; dir_it = dir_it + 1) {
			char* dir;
			dir = g_strdup (dir_collection[dir_it]);
			{
				char* _tmp4_;
				char* _tmp5_;
				char* sys_file;
#line 63 "ease-utilities.vala"
				sys_file = (_tmp5_ = ease_query_file (_tmp4_ = g_build_filename (EASE_SYS_DATA, dir, NULL), path), _g_free0 (_tmp4_), _tmp5_);
#line 64 "ease-utilities.vala"
				if (sys_file != NULL) {
#line 132 "ease-utilities.c"
					result = sys_file;
					_g_free0 (dir);
					data_dirs = (_vala_array_free (data_dirs, data_dirs_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (file);
#line 64 "ease-utilities.vala"
					return result;
#line 139 "ease-utilities.c"
				}
				_g_free0 (sys_file);
				_g_free0 (dir);
			}
		}
	}
	result = NULL;
	data_dirs = (_vala_array_free (data_dirs, data_dirs_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (file);
#line 67 "ease-utilities.vala"
	return result;
#line 151 "ease-utilities.c"
}


#line 78 "ease-utilities.vala"
char* ease_query_file (const char* dir, const char* path) {
#line 157 "ease-utilities.c"
	char* result = NULL;
	char* filename;
	GFile* file;
#line 78 "ease-utilities.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 78 "ease-utilities.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 80 "ease-utilities.vala"
	filename = g_build_filename (dir, path, NULL);
#line 81 "ease-utilities.vala"
	file = g_file_new_for_path (filename);
#line 83 "ease-utilities.vala"
	if (g_file_query_exists (file, NULL)) {
#line 171 "ease-utilities.c"
		result = filename;
		_g_object_unref0 (file);
#line 85 "ease-utilities.vala"
		return result;
#line 176 "ease-utilities.c"
	}
	result = NULL;
	_g_object_unref0 (file);
	_g_free0 (filename);
#line 87 "ease-utilities.vala"
	return result;
#line 183 "ease-utilities.c"
}


#line 90 "ease-utilities.vala"
double ease_dmax (double a, double b) {
#line 189 "ease-utilities.c"
	double result = 0.0;
	double _tmp0_ = 0.0;
#line 92 "ease-utilities.vala"
	if (a > b) {
#line 92 "ease-utilities.vala"
		_tmp0_ = a;
#line 196 "ease-utilities.c"
	} else {
#line 92 "ease-utilities.vala"
		_tmp0_ = b;
#line 200 "ease-utilities.c"
	}
	result = _tmp0_;
#line 92 "ease-utilities.vala"
	return result;
#line 205 "ease-utilities.c"
}


#line 95 "ease-utilities.vala"
double ease_dmin (double a, double b) {
#line 211 "ease-utilities.c"
	double result = 0.0;
	double _tmp0_ = 0.0;
#line 97 "ease-utilities.vala"
	if (a < b) {
#line 97 "ease-utilities.vala"
		_tmp0_ = a;
#line 218 "ease-utilities.c"
	} else {
#line 97 "ease-utilities.vala"
		_tmp0_ = b;
#line 222 "ease-utilities.c"
	}
	result = _tmp0_;
#line 97 "ease-utilities.vala"
	return result;
#line 227 "ease-utilities.c"
}


#line 100 "ease-utilities.vala"
gint ease_roundd (double num) {
#line 233 "ease-utilities.c"
	gint result = 0;
	double _tmp0_ = 0.0;
#line 102 "ease-utilities.vala"
	if ((num - ((gint) num)) < 0.5) {
#line 102 "ease-utilities.vala"
		_tmp0_ = num;
#line 240 "ease-utilities.c"
	} else {
#line 102 "ease-utilities.vala"
		_tmp0_ = num + 1;
#line 244 "ease-utilities.c"
	}
	result = (gint) _tmp0_;
#line 102 "ease-utilities.vala"
	return result;
#line 249 "ease-utilities.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




